//
// C++ Interface: kpgcast
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCAST_H
#define KPGCAST_H

#include "kpgobject.h"

class KPGCastsFolder;

/**
Item that represent cast. A cast specifies how to perform a conversion between two data types.

@author Lumir Vanek
*/

class KPGCast : public KPGObject
{
public:
    KPGCast(KPGCastsFolder *, const QString, pqxx::oid);
		KPGCast(KPGCastsFolder *, KPGCast *, const QString, pqxx::oid);
    ~KPGCast();

		virtual eNodeType type() const { return nodeCast; }
		void setProperties(const QString, pqxx::oid, const QString, pqxx::oid, const QString, pqxx::oid, const QString, pqxx::oid, const QString);
		void displayProperties(QWidget *);
		virtual bool refresh() { return true; }

protected:
	// Cast properties
	QString m_strContext;
	pqxx::oid m_oidSourceType;
	QString m_strSourceType;
	pqxx::oid m_oidTargetType;
	QString m_strTargetType;
	pqxx::oid m_oidCastFunc;
	QString m_strCastFunc;
	pqxx::oid m_oidNameSpace;
	QString m_strNameSpace;
};

#endif
