//
// C++ Interface: kpgconversion
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCONVERSION_H
#define KPGCONVERSION_H

#include "kpgobject.h"

class KPGConversionsFolder;

/**
Item that represent encoding conversion

@author Lumir Vanek
*/

class KPGConversion : public KPGObject
{
public:
    KPGConversion(KPGConversionsFolder *, const QString, pqxx::oid);
		KPGConversion(KPGConversionsFolder *, KPGConversion *, const QString, pqxx::oid);
    ~KPGConversion();

		virtual eNodeType type() const { return nodeConversion; }
		void setProperties(bool, const QString, const QString, pqxx::oid , const QString, const QString);
		void displayProperties(QWidget *);
		virtual bool refresh() { return true; }
		
protected:
	// conversion properties
	bool m_bIsDefault;
  QString m_strSourceEncoding;
	QString m_strDestinationEncoding;
 	pqxx::oid m_oidConversionProcedure;
	QString m_strConversionProcedure;
	QString m_strOwner;
};

#endif
