//
// C++ Interface: kpgfunction
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGFUNCTION_H
#define KPGFUNCTION_H

#include "kpgobject.h"

class KPGFunctionsFolder;

/**
Function

@author Lumir Vanek
*/

class KPGFunction : public KPGObject
{
public:
    KPGFunction(KPGFunctionsFolder *, const QString, pqxx::oid);
		KPGFunction(KPGFunctionsFolder *, KPGFunction *, const QString, pqxx::oid);
    ~KPGFunction();

		virtual eNodeType type() const { return nodeFunction; }
		void setProperties(const QString, bool, bool, bool, bool,	const QString, int,	const QString, const QString, const QString, pqxx::oid, const QString, const QString);
		void setArgTypes(const QString strArgTypes) { m_strArgTypes = strArgTypes; }
		void setSrc(const QString strSrc) { m_strSrc = strSrc; }
		void displayProperties(QWidget *);
		virtual bool refresh() { return true; }
		
		bool isSecdef() const { return m_bIsSecdef; }
		bool isStrict() const { return m_bIsStrict; }
		const QString getVolatile() const { return m_strVolatile; }
		int nArgs() const { return m_iNArgs; }
		const QString langName() const { return m_strLanName; }
		const QString argTypes() const { return  m_strArgTypes; }
		const QString source() const { return m_strSrc; }
		const QString returnTypName() const { return m_strReturnTypName; }
		    
protected:
	// Object properties
	// name is stored as text(0)
	bool m_bIsAgg;
	bool m_bIsSecdef;
	bool m_bIsStrict;
	bool m_bRetSet;
	QString m_strVolatile;
	int m_iNArgs;
	QString m_strBin;
	QString m_strAcl;
	pqxx::oid m_oidReturnType;
	QString m_strReturnTypName;
	QString m_strLanName;
	QString m_strFuncOwner;	
	QString m_strArgTypes;
	QString m_strSrc;
};

#endif
