//
// C++ Implementation: kpggroup
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpggroup.h"

// include files for KDE
#include <kdebug.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <ktextedit.h>

#include <qtable.h>

#include "kpggroupsfolder.h"
#include "../PropertyPages/kpggroupproppage.h"


KPGGroup::KPGGroup(KPGGroupsFolder *parent, const QString name)
  : KPGTreeItem(parent, name)
{
  setPixmap(0, *m_pIconGroup);
}


KPGGroup::KPGGroup(KPGGroupsFolder *parent, KPGGroup *after, const QString name)
  : KPGTreeItem(parent, after, name)
{
  setPixmap(0, *m_pIconGroup);
}


KPGGroup::~KPGGroup()
{
}

void KPGGroup::setProperties(int iSysId)
{
	m_iSysId = iSysId;
}

void KPGGroup::displayProperties(QWidget *widgetProperies)
{
	// Display server version info
	KPGGroupPropPage *pPropertyPage = static_cast <KPGGroupPropPage *> (widgetProperies);
	
	//---------------------------------------------------------------------------
	// Display properties
	QTable *pTableProperties = pPropertyPage->m_pTableProperties;
	
	//--- Header
	// field names
  QHeader* hHeader = pTableProperties->horizontalHeader();

  hHeader->setLabel(0, i18n("Name"));
	hHeader->setLabel(1, i18n("Value"));
	hHeader->setLabel(2, i18n("Description"));
	
	int iRow = 0;
  	
	//--- Name
	pTableProperties->setText(iRow, 0, i18n("Name"));
  pTableProperties->setText(iRow, 1, text(0));
	pTableProperties->setText(iRow++, 2, i18n("Group name"));
	
	//--- System ID
	pTableProperties->setText(iRow, 0, i18n("System ID"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iSysId));
	pTableProperties->setText(iRow++, 2, i18n("An arbitrary number to identify this group"));
	
	
	for(int nCol = 0; nCol < 3; nCol++)
  {
    pTableProperties->adjustColumn(nCol);
  }
	
	//--- Table of users -------------------------------------------------------------------
	
	QTable * pTableUsers = pPropertyPage->m_pTableUsers;
	
	hHeader = pTableUsers->horizontalHeader();
  hHeader->setLabel(0, i18n("User name"));
	
	pTableUsers->setNumRows(m_strListOfUsers.count());
	
	//--- List of users
	iRow = 0;
	for(QStringList::Iterator it = m_strListOfUsers.begin(); it != m_strListOfUsers.end(); ++it) 
	{
    pTableUsers->setText(iRow++, 0, *it);
  }
}

