/***************************************************************************
                          kpgobject  -  description
                             -------------------
    begin                : Ne no 1 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KPGOBJECT_H
#define KPGOBJECT_H

#include "kpgtreeitem.h"

/**
Base class for all objects, that have OID

@author Lumir Vanek
*/

class KPGObject : public KPGTreeItem
{
public:
    KPGObject(KPGTreeItem *, const QString, pqxx::oid);
		KPGObject(KPGTreeItem *, KPGTreeItem *, const QString, pqxx::oid);
    ~KPGObject();

		// Return PostgreSQL row identifier
		const pqxx::oid oid() const { return m_oid; }
		virtual bool hasOid() const { return true; }
		virtual KPGTreeItem * searchObject(const QString &, pqxx::oid); // search object with given path and OID
    virtual bool isSystemObject() const { return false; }
		
protected:

	// PostgreSQL row identifier
	pqxx::oid m_oid;
	
	// Object properties
	// name is stored as text(0)
	QString m_strDescription;
};

#endif
