//
// C++ Interface: kpgoperatorclass
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGOPERATORCLASS_H
#define KPGOPERATORCLASS_H

#include <kpgobject.h>

class KPGOperatorClassesFolder;

/**
Operator Class defines index access method operator classes. Each operator class defines semantics for index columns of a particular data type and a particular index access method. Note that there can be multiple operator classes for a given data type/access method combination, thus supporting multiple behaviors. 

@author Lumir Vanek
*/

class KPGOperatorClass : public KPGObject
{
public:
    KPGOperatorClass(KPGOperatorClassesFolder *, const QString, pqxx::oid);
		KPGOperatorClass(KPGOperatorClassesFolder *, KPGOperatorClass *, const QString, pqxx::oid);
    ~KPGOperatorClass();

		virtual eNodeType type() const { return nodeOperatorClass; }
		void setProperties(bool, pqxx::oid, const QString, pqxx::oid, const QString, const QString, const QString);
		void displayProperties(QWidget *);
		virtual bool refresh() { return true; }
		
protected:
	// Object properties
	// name is stored as text(0)
	bool m_bIsDefault;
	pqxx::oid m_oidDataType;
	QString m_strDataType;
	pqxx::oid m_oidKeyType;
	QString m_strKeyType;
	QString m_strAccessMethodName;
	QString m_strOwner;
};

#endif
