/***************************************************************************
                          kpgtablecolumn  -  description
                             -------------------
    begin                : So no 7 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kpgtablecolumn.h"

// include files for KDE
#include <kdebug.h>
#include <kmessagebox.h>
#include <klocale.h>

#include <qtable.h>

#include "../kpglinklabel.h"
#include "kpgtablecolumnsfolder.h"
#include "../PropertyPages/kpgtablecolumnproppage.h"

KPGTableColumn::KPGTableColumn(KPGTableColumnsFolder *parent, const QString name)
  : KPGTreeItem(parent, name)
{
  setPixmap(0, *m_pIconColumnOther);
}


KPGTableColumn::KPGTableColumn(KPGTableColumnsFolder *parent, KPGTableColumn *after, const QString name)
  : KPGTreeItem(parent, after, name)
{
  setPixmap(0, *m_pIconColumnOther);
}

KPGTableColumn::~KPGTableColumn()
{
}

void KPGTableColumn::setProperties(
	pqxx::oid oidType,
  pqxx::oid oidBaseType,
	const QString strTypName,
	const QString strDescription,
	int	iStatTarget,
	int iAttLen,
	int iAttNum, 
	int iAttNdims,
	int iAttTypmod,
	bool bByVal,
	bool bNotNull,
	bool bHasDef,
	bool bIsDropped,
	bool bIsLocal,
  const QString strStorage, 
	int iInhCount,
	const QString strAdSrc,
	const QString strNspName
	)
{
	m_oidType = oidType;
  m_oidBaseType = oidBaseType;
	m_strTypName = strTypName;
	m_strDescription = strDescription;
	m_iStatTarget = iStatTarget;
	m_iAttLen = iAttLen;
	m_iAttNum = iAttNum; 
	m_iAttNdims = iAttNdims;
	m_iAttTypmod = iAttTypmod;
	m_bByVal = bByVal;
	m_bNotNull = bNotNull;
	m_bHasDef = bHasDef;
	m_bIsDropped = bIsDropped;
	m_bIsLocal = bIsLocal;
  m_strStorage = strStorage;
	m_iInhCount =iInhCount ;
	m_strAdSrc = strAdSrc;
	m_strNspName = strNspName;
	
	//--- Set column type icon ---------------------------------------------------
	if((m_strTypName == "bpchar") || (m_strTypName == "varchar") || (m_strTypName == "text"))
	{
		setPixmap(0, *m_pIconColumnChar);
		return;
	}
	
	if((m_strTypName == "int") || (m_strTypName == "int2") || (m_strTypName == "int4") || (m_strTypName == "int8") || (m_strTypName == "float4") || (m_strTypName == "float8") || (m_strTypName == "numeric") || (m_strTypName == "serial4") || (m_strTypName == "serial8") || (m_strTypName == "money"))
	{
		setPixmap(0, *m_pIconColumnNum);
		return;
	}
			
	if((m_strTypName == "bool"))
	{
		setPixmap(0, *m_pIconColumnBool);
		return;
	}
	
	if((m_strTypName == "time") || (m_strTypName == "timetz") || (m_strTypName == "interval"))
	{
		setPixmap(0, *m_pIconColumnTime);
		return;
	}
	
	if((m_strTypName == "date") || (m_strTypName == "timestamp") || (m_strTypName == "timestamptz"))
	{
		setPixmap(0, *m_pIconColumnDate);
		return;
	}
	
	if((m_strTypName == "point") || (m_strTypName == "line") || (m_strTypName == "lseq") || (m_strTypName == "box") || (m_strTypName == "path") || (m_strTypName == "polygon") || (m_strTypName == "circle"))
	{
		setPixmap(0, *m_pIconColumnGeo);
		return;
	}
	
	if((m_strTypName == "bit") || (m_strTypName == "varbit"))
	{
		setPixmap(0, *m_pIconColumnBit);
		return;
	}
	
	if((m_strTypName == "bytea"))
	{
		setPixmap(0, *m_pIconColumnBin);
		return;
	}
	
	if((m_strTypName == "cidr") || (m_strTypName == "inet") || (m_strTypName == "macaddr"))
	{
		setPixmap(0, *m_pIconColumnNet);
		return;
	}
	
	//----------------------------------------------------------------------------
	
	if((m_strTypName == "oid"))
	{
		setPixmap(0, *m_pIconColumnOid);
		return;
	}
	
	if((m_strTypName == "xid"))
	{
		setPixmap(0, *m_pIconColumnXid);
		return;
	}
	
	if((m_strTypName == "tid"))
	{
		setPixmap(0, *m_pIconColumnTid);
		return;
	}
	
	if((m_strTypName == "cid"))
	{
		setPixmap(0, *m_pIconColumnCid);
		return;
	}
  
  if(m_oidBaseType != 0)
  {
    setPixmap(0, *m_pIconDomain);
  }
}

QPixmap *KPGTableColumn::getPixmapForType(const QString &strTypName)
{
	//--- Set column type icon ---------------------------------------------------
	if((strTypName == "bpchar") || (strTypName == "varchar") || (strTypName == "text"))
	{
		return m_pIconColumnChar;
	}
	
	if((strTypName == "int") || (strTypName == "int2") || (strTypName == "int4") || (strTypName == "int8") || (strTypName == "float4") || (strTypName == "float8") || (strTypName == "numeric") || (strTypName == "serial4") || (strTypName == "serial8") || (strTypName == "money"))
	{
		return m_pIconColumnNum;
	}
			
	if((strTypName == "bool"))
	{
		return m_pIconColumnBool;
	}
	
	if((strTypName == "time") || (strTypName == "timetz") || (strTypName == "interval"))
	{
		return m_pIconColumnTime;
	}
	
	if((strTypName == "date") || (strTypName == "timestamp") || (strTypName == "timestamptz"))
	{
		return m_pIconColumnDate;
	}
	
	if((strTypName == "point") || (strTypName == "line") || (strTypName == "lseq") || (strTypName == "box") || (strTypName == "path") || (strTypName == "polygon") || (strTypName == "circle"))
	{
		return m_pIconColumnGeo;
	}
	
	if((strTypName == "bit") || (strTypName == "varbit"))
	{
		return m_pIconColumnBit;
	}
	
	if((strTypName == "bytea"))
	{
		return m_pIconColumnBin;
	}
	
	if((strTypName == "cidr") || (strTypName == "inet") || (strTypName == "macaddr"))
	{
		return m_pIconColumnNet;
	}
	
	//----------------------------------------------------------------------------
	
	if((strTypName == "oid"))
	{
		return m_pIconColumnOid;
	}
	
	if((strTypName == "xid"))
	{
		return m_pIconColumnXid;
	}
	
	if((strTypName == "tid"))
	{
		return m_pIconColumnTid;
	}
	
	if((strTypName == "cid"))
	{
		return m_pIconColumnCid;
	}
  
  qWarning( "KPGTableColumn::getPixmapForType - Unknown column type: " + strTypName );
	return m_pIconColumnOther;
}

void KPGTableColumn::displayProperties(QWidget *widgetProperies)
{
	// Display server version info
	KPGTableColumnPropPage *pPropertyPage = static_cast <KPGTableColumnPropPage *> (widgetProperies);
	
	//---------------------------------------------------------------------------
	// Display properties
	QTable *pTableProperties = pPropertyPage->m_pTableProperties;
	
	//--- Header
	// field names
  QHeader* hHeader = pTableProperties->horizontalHeader();

  hHeader->setLabel(0, i18n("Name"));
	hHeader->setLabel(1, i18n("Value"));
	hHeader->setLabel(2, i18n("Description"));
	
	int iRow = 0;
  	
	//--- Name
	pTableProperties->setText(iRow, 0, i18n("Name"));
  pTableProperties->setText(iRow, 1, text(0));
	pTableProperties->setText(iRow++, 2, i18n("The column name"));
	
	//--- Type Name
	pTableProperties->setText(iRow, 0, i18n("Type"));
  KPGLinkLabel *pLabel = new KPGLinkLabel( pTableProperties, "Type" );
	pLabel->setValues(m_oidType, m_strTypName);
	pTableProperties->setCellWidget(iRow, 1, pLabel);
	pTableProperties->setText(iRow++, 2, i18n("The column type"));
	
	//--- Created as
	pTableProperties->setText(iRow, 0, i18n("Created as"));
  QString strType(m_strTypName);
	
	if(m_iAttNdims > 0)
		strType = strType.mid(1, strType.length() - 1); // remove trailing _
	
	if(strType == "bpchar") 
	{
		strType = QString("char(%1)").arg(m_iAttTypmod - 4);
	}
	else
	if(strType == "varchar") 
	{
		strType = QString("varchar(%1)").arg(m_iAttTypmod - 4);
	}	
	else
	if(strType == "int2") 
	{
		strType = "smallint";
	}
	else
	if(strType == "int4") 
	{
		strType = "int";
	}
	else
	if(strType == "int8") 
	{
		strType = "bigint";
	}
	else
	if(strType == "float4") 
	{
		strType = "real";
	}
	if(strType == "float8") 
	{
		strType = "float";
	}
	else
	if(strType == "numeric") 
	{
		strType = QString("decimal(%1, %2)").arg((m_iAttTypmod - 4)  / 65536).arg((m_iAttTypmod - 4)  % 65536);
	}	
	else
	if(strType == "serial") 
	{
		strType = "serial";
	}
	else
	if(strType == "serial8") 
	{
		strType = "bigserial";
	}
	else
	if(strType == "bit") 
	{
		strType = QString("bit(%1)").arg(m_iAttTypmod);
	}
	else
	if(strType == "varbit") 
	{
		strType = QString("varbit(%1)").arg(m_iAttTypmod);
	}	
	
	if(m_iAttNdims > 0)
		{
		  for(int i = 0; i < m_iAttNdims; i++)
				strType.append(" [?]");
		}
	
	pTableProperties->setText(iRow, 1, strType);
	pTableProperties->setText(iRow++, 2, i18n("The column type specified in CREATE TABLE statement"));
		
	//--- Type length
	pTableProperties->setText(iRow, 0, i18n("Type length"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iAttLen));
	pTableProperties->setText(iRow++, 2, i18n("For a fixed-size type, typlen is the number of bytes in the internal representation of the type. But for a variable-length type, typlen is negative. -1 indicates a \"varlena\" type (one that has a length word), -2 indicates a null-terminated C string."));
	
	//--- Description
	pTableProperties->setText(iRow, 0, i18n("Description"));
  pTableProperties->setText(iRow, 1, m_strDescription);
	pTableProperties->setText(iRow++, 2, i18n("Description of the column"));
	
	//--- Statistics target
	pTableProperties->setText(iRow, 0, i18n("Statistics target"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iStatTarget));
	pTableProperties->setText(iRow++, 2, i18n("Controls the level of detail of statistics accumulated for this column by ANALYZE. A zero value indicates that no statistics should be collected. A negative value says to use the system default statistics target. The exact meaning of positive values is data type-dependent. For scalar data types, attstattarget is both the target number of \"most common values\" to collect, and the target number of histogram bins to create."));
	
	
	//--- Attribute number
	pTableProperties->setText(iRow, 0, i18n("Attribute number"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iAttNum));
	pTableProperties->setText(iRow++, 2, i18n("The number of the column. Ordinary columns are numbered from 1 up. System columns, such as oid, have (arbitrary) negative numbers."));
	
	//--- Number of dimensions
	pTableProperties->setText(iRow, 0, i18n("Number of dimensions"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iAttNdims));
	pTableProperties->setText(iRow++, 2, i18n("Number of dimensions, if the column is an array type; otherwise 0. (Presently, the number of dimensions of an array is not enforced, so any nonzero value effectively means \"it's an array\".) "));
	
	//--- Type mode
	pTableProperties->setText(iRow, 0, i18n("Type mode"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iAttTypmod));
	pTableProperties->setText(iRow++, 2, i18n("Records type-specific data supplied at table creation time (for example, the maximum length of a varchar column). It is passed to type-specific input functions and length coercion functions. The value will generally be -1 for types that do not need atttypmod. "));
	
	//--- By Value
	pTableProperties->setText(iRow, 0, i18n("By value"));
  pTableProperties->setText(iRow, 1, (m_bByVal) ? i18n("True") : i18n("False"));
	pTableProperties->setText(iRow++, 2, i18n("Determines whether internal routines pass a value of this type by value or by reference. It had better be false if typlen is not 1, 2, or 4 (or 8 on machines where Date is 8 bytes). Variable-length types are always passed by reference. Note that typbyval can be false even if the length would allow pass-by-value; this is currently true for type float4, for example."));
	
	//--- Not null
	pTableProperties->setText(iRow, 0, i18n("Not null"));
  pTableProperties->setText(iRow, 1, (m_bNotNull) ? i18n("True") : i18n("False"));
	pTableProperties->setText(iRow++, 2, i18n("This represents a not-null constraint. It is possible to change this column to enable or disable the constraint."));
	
	//--- Not null
	pTableProperties->setText(iRow, 0, i18n("Has default"));
  pTableProperties->setText(iRow, 1, (m_bHasDef) ? i18n("True") : i18n("False"));
	pTableProperties->setText(iRow++, 2, i18n("This column has a default value, in which case there will be a corresponding entry in the pg_attrdef catalog that actually defines the value."));
	
	//--- Is dropped
	pTableProperties->setText(iRow, 0, i18n("Is dropped"));
  pTableProperties->setText(iRow, 1, (m_bIsDropped) ? i18n("True") : i18n("False"));
	pTableProperties->setText(iRow++, 2, i18n("This column has been dropped and is no longer valid. A dropped column is still physically present in the table, but is ignored by the parser and so cannot be accessed via SQL."));
	
	//--- Is local
	pTableProperties->setText(iRow, 0, i18n("Is local"));
  pTableProperties->setText(iRow, 1, (m_bIsLocal) ? i18n("True") : i18n("False"));
	pTableProperties->setText(iRow++, 2, i18n("This column is defined locally in the relation. Note that a column may be locally defined and inherited simultaneously. "));
  
  //--- Storage
  pTableProperties->setText(iRow, 0, i18n("Storage"));
  pTableProperties->setText(iRow, 1, m_strStorage);
  pTableProperties->setText(iRow++, 2, i18n("Column storage. For TOAST-able data types, this can be altered after column creation to control storage policy."));
	
	//--- Type mode
	pTableProperties->setText(iRow, 0, i18n("Inherited count"));
  pTableProperties->setText(iRow, 1, QString("%1").arg(m_iInhCount));
	pTableProperties->setText(iRow++, 2, i18n("The number of direct ancestors this column has. A column with a nonzero number of ancestors cannot be dropped nor renamed. "));
	
	//--- Default value
	pTableProperties->setText(iRow, 0, i18n("Default value"));
  pTableProperties->setText(iRow, 1, m_strAdSrc);
	pTableProperties->setText(iRow++, 2, i18n("A human-readable representation of the default value"));
	
	//--- Namespace
	pTableProperties->setText(iRow, 0, i18n("Namespace"));
  pTableProperties->setText(iRow, 1, m_strNspName);
	pTableProperties->setText(iRow++, 2, i18n("Name of the datatype namespace"));

			
	for(int nCol = 0; nCol < 3; nCol++)
  {
    pTableProperties->adjustColumn(nCol);
  }
}
