//
// C++ Interface: kpgtableconstraint
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGTABLECONSTRAINT_H
#define KPGTABLECONSTRAINT_H

#include "kpgobject.h"

class KPGTableConstraintsFolder;

/**
Base class for all table constraints - primary key, foreign key, unique and check

@author Lumir Vanek
*/

class KPGTableConstraint : public KPGObject
{
public:
    KPGTableConstraint(KPGTableConstraintsFolder *, const QString, pqxx::oid);
		KPGTableConstraint(KPGTableConstraintsFolder *, KPGTableConstraint *, const QString, pqxx::oid);
    ~KPGTableConstraint();

		void setProperties(const QString, bool, bool, const QString);
		virtual bool refresh() { return true; }
				
protected:
	// Object properties
	// name is stored as text(0)
	bool m_bIsDeferrable;
	bool m_bIsDeferred;
	QString m_strNspName;		
};

#endif
