//
// C++ Implementation: kpgtableindex
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgtableindex.h"

#include "kpgtableindexesfolder.h"

KPGTableIndex::KPGTableIndex(KPGTableIndexesFolder *parent, const QString name, pqxx::oid _oid)
  : KPGObject(parent, name, _oid)
{
	setPixmap(0, *m_pIconFolderRed);
}

KPGTableIndex::KPGTableIndex(KPGTableIndexesFolder *parent, KPGTableIndex *after, const QString name, pqxx::oid _oid)
  : KPGObject(parent, after, name, _oid)
{
	setPixmap(0, *m_pIconFolderRed);
}


KPGTableIndex::~KPGTableIndex()
{
}

// For PostgreSQL 7.x or older
void KPGTableIndex::setProperties(
		const QString strDescription,
		const QString strIndKey,
		bool bIsUnique,
		bool bIsPrimary,
		bool bIsClustered,
    const QString &strIndexdef
	)
{
	m_strDescription = strDescription;
	m_strIndKey = strIndKey;
	m_bIsUnique = bIsUnique;
	m_bIsPrimary = bIsPrimary;
	m_bIsClustered = bIsClustered;
  m_oidTablespace = 0;
  m_strIndexdef = strIndexdef;
}

// For PostgreSQL 8 or newer
void KPGTableIndex::setProperties(
    const QString strDescription,
    const QString strIndKey,
    bool bIsUnique,
    bool bIsPrimary,
    bool bIsClustered,
    pqxx::oid oidTablespace,    
    QString strTablespace,
    const QString &strIndexdef     
  )
{
  m_strDescription = strDescription;
  m_strIndKey = strIndKey;
  m_bIsUnique = bIsUnique;
  m_bIsPrimary = bIsPrimary;
  m_bIsClustered = bIsClustered;
  m_oidTablespace = oidTablespace;
  m_strTablespace = strTablespace;
  m_strIndexdef = strIndexdef;
}

