//
// C++ Implementation: kpgtableitemsfolder
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgtableitemsfolder.h"

// include files for KDE
#include <klistbox.h>
#include <kcombobox.h>
#include <kdebug.h>

#include "kpgitemsfolder.h"

KPGTableItemsFolder::KPGTableItemsFolder(KPGTable *parent, const QString name)
  : KPGTreeItem(parent, name)
{
  setPixmap(0, *m_pIconFolderBlue);
}

KPGTableItemsFolder::KPGTableItemsFolder(KPGTable *parent, KPGTableItemsFolder *after, const QString name)
  : KPGTreeItem(parent, after, name)
{
  setPixmap(0, *m_pIconFolderBlue);
}

KPGTableItemsFolder::~KPGTableItemsFolder()
{
}

bool KPGTableItemsFolder::refresh()
{
	KPGTreeItem * pItemParent = static_cast <KPGTreeItem *> (parent());
	if(!pItemParent)
		{ 
		  kdError() << "Failed to find DB connection " << endl;
			return 0;
		}
	
	KPGConnection *pDbConnection = connection();
	work pqxxXaction(*pDbConnection, "refresh");
		
	return refresh(pqxxXaction, (static_cast <KPGTable *> (pItemParent))->oid());
}

void KPGTableItemsFolder::fillListBoxWithChildItems(QListBox *pListBox)
{
  QListViewItem * pItem = firstChild();
  while(pItem)
  {
    KPGTreeItem *pTreeItem = static_cast <KPGTreeItem *> (pItem); 
    
    pListBox->insertItem(new KPGListBoxItem(* pTreeItem->pixmap(0), pTreeItem->text(0), pTreeItem->type()));    
    
    pItem = pItem->nextSibling();
  }
}

void KPGTableItemsFolder::fillListBoxWithChildItems(KListBox *pListBox)
{
  QListViewItem * pItem = firstChild();
  while(pItem)
  {
    KPGTreeItem *pTreeItem = static_cast <KPGTreeItem *> (pItem); 
    
    pListBox->insertItem(new KPGListBoxItem(* pTreeItem->pixmap(0), pTreeItem->text(0), pTreeItem->type()));    
    
    pItem = pItem->nextSibling();
  }
}

void KPGTableItemsFolder::fillComboBoxWithChildItems(KComboBox *pComboBox)
{
  QListViewItem * pItem = firstChild();
  while(pItem)
  {
    pComboBox->insertItem(* pItem->pixmap(0), pItem->text(0));   
    
    pItem = pItem->nextSibling();
  }
}
