//
// C++ Interface: %{MODULE}
//
// Description: 
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGTABLESPACE_H
#define KPGTABLESPACE_H

#include "kpgobject.h"

class KPGTablespacesFolder;

/**
Item that represent Tablespace. Tables can be placed in particular tablespaces to aid administration of disk layout. 

@author Lumir Vanek
*/

class KPGTablespace : public KPGObject
{
public:
    KPGTablespace(KPGTablespacesFolder *, const QString, pqxx::oid);
		KPGTablespace(KPGTablespacesFolder *, KPGTablespace *, const QString, pqxx::oid);
    ~KPGTablespace();
		
		virtual eNodeType type() const { return nodeTablespace; }
    virtual bool isSystemObject() const { return m_bIsSystemObject; }
		void setProperties(const QString, const QString, const QString);
		void displayProperties(QWidget *);
		virtual bool refresh() { return true; }
		
    const QString & location() const { return m_strLocation; }
    const QString & owner() const { return m_strOwner; }
    
protected:
	// Tablespace properties
	QString m_strOwner;
	QString m_strACL;
	QString m_strLocation;
  
  bool m_bIsSystemObject;
};

#endif
