//
// C++ Interface: kpgtype
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGTYPE_H
#define KPGTYPE_H

#include "kpgobject.h"

class KPGTypesFolder;

/**
Item that represent data type.  Base types (scalar types) are created with CREATE TYPE. A composite type is automatically created for each table in the database, to represent the row structure of the table. It is also possible to create composite types with CREATE TYPE AS and domains with CREATE DOMAIN. 

@author Lumir Vanek
*/

class KPGType : public KPGObject
{
public:
    KPGType(KPGTypesFolder *, const QString, pqxx::oid);
		KPGType(KPGTypesFolder *, KPGType *, const QString, pqxx::oid);
    ~KPGType();

		virtual eNodeType type() const { return nodeType; }
		void setProperties(const QString, const QString,	int,	bool, bool,	const QString, const QString, const QString, pqxx::oid, const QString, pqxx::oid, const QString,	pqxx::oid, const QString ,	pqxx::oid, const QString, const QString);
		void displayProperties(QWidget *);
		void displayAttributes(QWidget *);
		virtual bool refresh() { return true; }
		bool refresh(pqxx::work &);
		pqxx::result resultAttributes() const { return m_pqxxResultAttributes; }
		
    const QString & kind() const { return m_strKind; } // Type kind - e.g. base, composite, ...
    const QString & owner() const { return m_strOwner; }
    
protected:
  	// Attributes
		int m_iTypLen; 
		bool m_bByVal; 
		QString m_strKind;
		bool m_bIsDefined; 
		QString m_strTypDelim;
		QString m_strTypAlign;
		QString m_strTypStorage;
		pqxx::oid m_oidTypElem;
		QString m_strElement;
		pqxx::oid m_oidInputFunc;
		QString m_strInputFunc;
		pqxx::oid m_oidOutputFunc;
		QString m_strOutputFunc;
		pqxx::oid m_oidTable;
		QString m_strTableName;
		QString m_strOwner;
		
		// results that will be displaied in properties window
		pqxx::result m_pqxxResultAttributes;
};

#endif
