/***************************************************************************
                          kpgdatabaseproppage  -  description
                             -------------------
    begin                : So led 31 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kpgdatabaseproppage.h"

#include <qtable.h>

#include <qiconset.h> 
#include <ktabwidget.h>

#include "../DbObjects/kpgtreeitem.h"

#include <qtable.h>  

#include <kdebug.h>

#include "../kpglinklabel.h"

KPGDatabasePropPage::KPGDatabasePropPage(QWidget *parent, const char *name)
 : KPGDatabasePropPageBase(parent, name)
{
	//m_pTableProperties->verticalHeader()->setResizeEnabled( false );
	m_pTabWidget->setTabIconSet(tabCasts, QIconSet(*KPGTreeItem::m_pIconCast)); 
	m_pTabWidget->setTabIconSet(tabLanguages, QIconSet(*KPGTreeItem::m_pIconLanguage)); 
	m_pTabWidget->setTabIconSet(tabSchemas, QIconSet(*KPGTreeItem::m_pIconSchema)); 
}


KPGDatabasePropPage::~KPGDatabasePropPage()
{
}

void KPGDatabasePropPage::slotTablePropDblClicked(int iRow, int iCol, int /*iButton*/, const QPoint & /*ptMousePos*/)
{
    QWidget *w = m_pTableProperties->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableCastsDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableCasts->cellWidget(iRow, iCol);
		if (w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableLanguagesDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableLanguages->cellWidget(iRow, iCol);
		if (w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGDatabasePropPage::slotTableSchemasDblClicked(int iRow, int iCol,int,const QPoint&)
{
    QWidget *w = m_pTableSchemas->cellWidget(iRow, iCol);
		if (w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

#include "kpgdatabaseproppage.moc"
