//
// C++ Implementation: kpgschemaproppage
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "kpgschemaproppage.h"

#include <qiconset.h> 
#include <qtable.h>  

#include <kdebug.h>
#include <ktabwidget.h>

#include "../kpglinklabel.h"

#include "../DbObjects/kpgtreeitem.h"

KPGSchemaPropPage::KPGSchemaPropPage(QWidget *parent, const char *name)
 : KPGSchemaPropPageBase(parent, name)
{
	m_pTabWidget->setTabIconSet(tabAggregates, QIconSet(*KPGTreeItem::m_pIconAggregate)); 
	m_pTabWidget->setTabIconSet(tabConversions, QIconSet(*KPGTreeItem::m_pIconConversion));
	m_pTabWidget->setTabIconSet(tabDomains, QIconSet(*KPGTreeItem::m_pIconDomain));
	m_pTabWidget->setTabIconSet(tabFunctions, QIconSet(*KPGTreeItem::m_pIconFunctionC));
	m_pTabWidget->setTabIconSet(tabOperatorClasses, QIconSet(*KPGTreeItem::m_pIconOperatorClass));
	m_pTabWidget->setTabIconSet(tabOperators, QIconSet(*KPGTreeItem::m_pIconOperator));
	m_pTabWidget->setTabIconSet(tabSequences, QIconSet(*KPGTreeItem::m_pIconSequence));
	m_pTabWidget->setTabIconSet(tabTables, QIconSet(*KPGTreeItem::m_pIconTable));
	m_pTabWidget->setTabIconSet(tabTypes, QIconSet(*KPGTreeItem::m_pIconTypeStandalone));
	m_pTabWidget->setTabIconSet(tabViews, QIconSet(*KPGTreeItem::m_pIconView));
}


KPGSchemaPropPage::~KPGSchemaPropPage()
{
}

void KPGSchemaPropPage::slotTablePropDblClicked(int iRow, int iCol, int, const QPoint &)
{
    QWidget *w = m_pTableProperties->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotCurrentTabChanged(QWidget *w)
{
    emit sigCurrentTabChanged(this, w);
}

void KPGSchemaPropPage::slotTableAggregatesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableAggregates->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableConversionsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableConversions->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableDomainsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableDomains->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableFunctionsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableFunctions->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableOpClassesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableOperatorClasses->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableOperatorsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableOperators->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableSequencesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableSequences->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableTablesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableTables->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableTypesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableTypes->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGSchemaPropPage::slotTableViewsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableViews->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}


#include "kpgschemaproppage.moc"
