/***************************************************************************
                          kpgtableproppage  -  description
                             -------------------
    begin                : So led 31 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "kpgtableproppage.h"

#include <qiconset.h>
#include <qtable.h>  

#include <ktabwidget.h>

#include "../kpglinklabel.h"
#include "../DbObjects/kpgtreeitem.h"

KPGTablePropPage::KPGTablePropPage(QWidget *parent, const char *name)
 : KPGTablePropPageBase(parent, name)
{
	m_pTabWidget->setTabIconSet(tabColumns, QIconSet(*KPGTreeItem::m_pIconColumnOther)); 
	m_pTabWidget->setTabIconSet(tabConstraints, QIconSet(*KPGTreeItem::m_pIconPrimaryKeyConstr)); 
	m_pTabWidget->setTabIconSet(tabIndexes, QIconSet(*KPGTreeItem::m_pIconIndex)); 
	m_pTabWidget->setTabIconSet(tabRules, QIconSet(*KPGTreeItem::m_pIconRule)); m_pTabWidget->setTabIconSet(tabTriggers, QIconSet(*KPGTreeItem::m_pIconTrigger)); 
}


KPGTablePropPage::~KPGTablePropPage()
{
}

void KPGTablePropPage::slotTablePropDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableProperties->cellWidget(iRow, iCol);
    if(w == 0)
      return;
          
    KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
    pqxx::oid _oid = pLabel->oid();
      
    if(_oid != 0)
      emit sigSearchObject(_oid);
}

void KPGTablePropPage::slotTableColumnsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableColumns->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGTablePropPage::slotTableConstraintsDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableConstraints->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGTablePropPage::slotTableIndexesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableIndexes->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGTablePropPage::slotTableRulesDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableRules->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

void KPGTablePropPage::slotTableTriggersDblClicked(int iRow, int iCol, int, const QPoint&)
{
    QWidget *w = m_pTableTriggers->cellWidget(iRow, iCol);
		if(w == 0)
			return;
					
		KPGLinkLabel *pLabel = static_cast <KPGLinkLabel *> (w);
		pqxx::oid _oid = pLabel->oid();
			
		if(_oid != 0)
			emit sigSearchObject(_oid);
}

#include "kpgtableproppage.moc"
