//
// C++ Interface: kpgcreaterulewidget1
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGCREATERULEWIDGET1_H
#define KPGCREATERULEWIDGET1_H

#include "kpgcreaterulewidget1base.h"

class KPGSyntaxHighlighter;

/**
Widget for create rule Wizard

@author Lumir Vanek
*/

class KPGCreateRuleWidget1 : public KPGCreateRuleWidget1Base
{
Q_OBJECT
public:
    KPGCreateRuleWidget1(QWidget *parent, const char *name, const QString &, const QString &);
    ~KPGCreateRuleWidget1();
    
    const QString getSQL() const;
    
protected:
    QString m_strTableName; // name of the table
    QString m_strNamespace; // name of the namespace
    
  /** Syntax highlighter for rule command */
  KPGSyntaxHighlighter *m_pSyntaxHighlighter;    

protected slots:

		virtual void slotRuleNameChanged(const QString&);
		virtual void slotDoAlsoToggled(bool);
		virtual void slotDoInsteadToggled(bool);
		virtual void slotDoNothingToggled(bool);
    virtual void slotEventActivated(const QString &);
								
signals:
		void sigEnableNextButton(bool);		
};

#endif
