//
// C++ Interface: kpgnewobjectdialog
//
// Description: 
//
//
// Author: Lumir Vanek <lvanek@users.sourceforge.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef KPGNEWOBJECTDIALOG_H
#define KPGNEWOBJECTDIALOG_H

#include "kpgnewobjectdialogbase.h"

#include <qstring.h>

/**
Dialog for selecting new object type

@author Lumir Vanek
*/

class KPGNewObjectDialog : public KPGNewObjectDialogBase
{
Q_OBJECT
public:
    enum eNewObjectIconSet { iconSetServer = 0, iconSetDatabase, iconSetSchema, iconSetTable };
		
		KPGNewObjectDialog(QWidget *parent, const char *name, eNewObjectIconSet, const QString&, bool);
    ~KPGNewObjectDialog();
						
		const QString & objectType() const { return m_strObjectType; }
		
protected:
	QString m_strObjectType;
	QString m_strCaption;	
		
protected slots:

    virtual void languageChange();
    virtual void slotItemDoubleClicked(QIconViewItem *);
    virtual void slotItemSelectionChanged(QIconViewItem *);
		virtual void accept();
};

#endif
