/***************************************************************************
                          kpgsqlquerresultwindow.cpp  -  description
                             -------------------
    begin                : So led 17 2004
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kpgsqlquerresultwindow.h"

//#include <qmultilineedit.h>
#include <qtable.h>

#include <ktextedit.h>

// application specific includes
#include "kpgsyntaxhighlighter.h"

#include "kpogre.h"
#include "kpgconfiguration.h"
#include "kpgsqleditorsettings.h"


KPGSqlQueryResultWindow::KPGSqlQueryResultWindow(QWidget *parent, const char *name )
: KPGSqlQueryResultWindowBase(parent, name)
{
  m_pSyntaxHighlighter = new KPGSyntaxHighlighter(m_pTextEditQuery);
  m_pTextEditQuery->setText("SELECT * FROM ;");
  m_pTextEditQuery->setSelection(14 , 0, 14, 0),
/*
  m_pTableResult = new QTable(this);
  m_pTableResult->verticalHeader()->setResizeEnabled( FALSE );
	m_pTableResult->setSelectionMode(QTable::NoSelection);*/

 	// Apply current configuration
	slotSqlEditorSettingsChanged();
 	// and make sure to be informed about its changes.
	connect( KPoGreApp::configuration()->sqleditor(), SIGNAL(sigChanged()), this, SLOT(slotSqlEditorSettingsChanged()) );
	
	connect(m_pTextEditQuery, SIGNAL(textChanged()), this, SLOT(slotTextEditQueryTextChanged()));
	connect(m_pTextEditQuery, SIGNAL(copyAvailable(bool)), this, SLOT(slotTextEditCopyAvailable(bool)));
	connect(m_pTextEditQuery, SIGNAL(undoAvailable(bool)), this, SLOT(slotTextEditUndoAvailable(bool)));
	connect(m_pTextEditQuery, SIGNAL(redoAvailable(bool)), this, SLOT(slotTextEditRedoAvailable(bool)));
	
	m_bQueryTextChanged = false;
}

KPGSqlQueryResultWindow::~KPGSqlQueryResultWindow()
{
  delete m_pSyntaxHighlighter;
}

void KPGSqlQueryResultWindow::slotSqlEditorSettingsChanged()
{
	m_pSyntaxHighlighter->setColorDefaultText( KPoGreApp::configuration()->sqleditor()->colorDefaultText() );
	m_pSyntaxHighlighter->setColorKeyWords( KPoGreApp::configuration()->sqleditor()->colorKeyWords() );
	m_pSyntaxHighlighter->setColorDataTypes( KPoGreApp::configuration()->sqleditor()->colorDataTypes() );
	m_pSyntaxHighlighter->setColorOperators( KPoGreApp::configuration()->sqleditor()->colorOperators() );
	m_pSyntaxHighlighter->setColorQuotedStrings( KPoGreApp::configuration()->sqleditor()->colorQuotedStrings() );
	m_pSyntaxHighlighter->setColorNumbers( KPoGreApp::configuration()->sqleditor()->colorNumbers() );
  m_pSyntaxHighlighter->setColorComments( KPoGreApp::configuration()->sqleditor()->colorComments() );
	
	m_pSyntaxHighlighter->rehighlight();
}

void KPGSqlQueryResultWindow::slotServerChanged(const QString& strServer)
{
	emit sigRequestDatabasesList(this, strServer);    
}

void KPGSqlQueryResultWindow::slotTextEditQueryTextChanged()
{
	if(!m_bQueryTextChanged)
	{
		m_bQueryTextChanged = true;
		emit sigQueryTextChanged(this);
	}
}

void KPGSqlQueryResultWindow::slotTextEditCopyAvailable(bool bCopyAvailable)
{
	emit sigCopyAvailable(this, bCopyAvailable);   
}

void KPGSqlQueryResultWindow::slotTextEditUndoAvailable(bool bUndoAvailable)
{
	emit sigUndoAvailable(this, bUndoAvailable);   
}

void KPGSqlQueryResultWindow::slotTextEditRedoAvailable(bool bRedoAvailable)
{
	emit sigRedoAvailable(this, bRedoAvailable);   
}

bool KPGSqlQueryResultWindow::resultEmpty() const
{ 
	return m_pTableResult->numRows() == 0; 
}

