/***************************************************************************
                          kpogredoc.h  -  description
                             -------------------
    begin                : � �n  6 16:08:39 CEST 2002
    copyright            : (C) 2002 by Dominik Sacher
    email                : dsacher@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPOGREDOC_H
#define KPOGREDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qptrlist.h>

// include files for KDE
#include <kurl.h>

// forward declaration of the KPoGre classes
class KPoGreView;

/**	KPoGreDoc provides a document object for a document-view model.
  *
  * The KPoGreDoc class provides a document object that can be used in conjunction with the classes KPoGreApp and KPoGreView
  * to create a document-view model for standard KDE applications based on KApplication and KMainWindow. Thereby, the document object
  * is created by the KPoGreApp instance and contains the document structure with the according methods for manipulation of the document
  * data by KPoGreView objects. Also, KPoGreDoc contains the methods for serialization of the document data from and to files.
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 1.2 code generation
  */
class KPoGreDoc : public QObject
{
  Q_OBJECT
  public:
    /** Constructor for the fileclass of the application */
    KPoGreDoc(QWidget *parent, const char *name=0);

    /** Destructor for the fileclass of the application */
    ~KPoGreDoc();

    /** adds a view to the document which represents the document contents. Usually this is your main view. */
    void addView(KPoGreView *view);

    /** removes a view from the list of currently connected views */
    void removeView(KPoGreView *view);

    /** sets the modified flag for the document after a modifying action on the view connected to the document.*/
    void setModified(bool _m=true){ modified=_m; emit sigModified(); };

    /** returns if the document is modified or not. Use this to determine if your document needs saving by the user on closing.*/
    bool isModified(){ return modified; };

    /** "save modified" - asks the user for saving if the document is modified */
    bool saveModified();	

    /** deletes the document's contents */
    void deleteContents();

    /** initializes the document generally */
    bool newDocument();

    /** closes the acutal document */
    void closeDocument();

    /** loads the document by filename and format and emits the updateViews() signal */
    bool openDocument(const KURL& url, const char *format=0);

    /** saves the document under filename and format.*/	
    bool saveDocument(const KURL& url, const char *format=0);

    /** returns the KURL of the document */
    const KURL& URL() const;

    /** sets the URL of the document */
	  void setURL(const KURL& url);

protected:

  /** the list of the views currently connected to the document */
  static QPtrList<KPoGreView> *pViewList;

  /** the modified flag of the current document */
  bool modified;

  KURL doc_url;
    
	
signals:
  void sigModified();

public slots:
    /** calls repaint() on all views connected to the document object and is called by the view by which the document has been changed.
     * As this view normally repaints itself, it is excluded from the paintEvent.
     */
    void slotUpdateAllViews(KPoGreView *sender);
};

#endif // KPOGREDOC_H
