/***************************************************************************
                          kpogreview.cpp  -  description
                             -------------------
    begin                : Fre Sep  7 16:06:25 CEST 2001
    copyright            : (C) 2004 by Lumir Vanek
    email                : lvanek@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <pqxx/util.h> 
 
// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qregexp.h>
#include <qtextcodec.h>
#include <qptrlist.h> 
#include <qwidgetstack.h> 

// include files for KDE
#include <kiconloader.h>
#include <kdebug.h>
#include <kmessagebox.h>
#include <kcursor.h>
#include <kpopupmenu.h>
#include <ktextedit.h>
#include <kcombobox.h>
//#include <klineedit.h>

// application specific includes
#include "kpogreview.h"
#include "kpogredoc.h"
#include "kpogre.h"
#include "kpgconnectdialog.h"
#include "kpgsyntaxhighlighter.h"
#include "kpgsqlquerresultwindow.h"

// Database objects includes
#include "DbObjects/kpgconnection.h"
#include "DbObjects/kpgserver.h"

#include "DbObjects/kpgtablespacesfolder.h"
#include "DbObjects/kpgtablespace.h"
#include "DbObjects/kpguser.h"
#include "DbObjects/kpgusersfolder.h"
#include "DbObjects/kpggroupsfolder.h"
#include "DbObjects/kpggroup.h"
#include "DbObjects/kpgdatabase.h"

#include "DbObjects/kpgschema.h"
#include "DbObjects/kpgtablesfolder.h"
#include "DbObjects/kpgviewsfolder.h"
#include "DbObjects/kpgtypesfolder.h"
#include "DbObjects/kpgview.h"
#include "DbObjects/kpgtable.h"
#include "DbObjects/kpgtype.h"
#include "DbObjects/kpgsequencesfolder.h"
#include "DbObjects/kpgsequence.h"
#include "DbObjects/kpgdomainsfolder.h"
#include "DbObjects/kpgdomain.h"
#include "DbObjects/kpgdomainconstraint.h"
#include "DbObjects/kpgdomainconstraintsfolder.h"
#include "DbObjects/kpgfunctionsfolder.h"
#include "DbObjects/kpgfunction.h"
#include "DbObjects/kpgoperatorsfolder.h"
#include "DbObjects/kpgoperator.h"
#include "DbObjects/kpgaggregate.h"
#include "DbObjects/kpglanguage.h"
#include "DbObjects/kpglanguagesfolder.h"

#include "DbObjects/kpgtablecolumnsfolder.h"
#include "DbObjects/kpgtablecolumn.h"
#include "DbObjects/kpgtableconstraintsfolder.h"
#include "DbObjects/kpgprimarykeyconstr.h"
#include "DbObjects/kpgforeignkeyconstr.h"
#include "DbObjects/kpgcheckconstr.h"
#include "DbObjects/kpguniqueconstr.h"
#include "DbObjects/kpgtableindexesfolder.h"
#include "DbObjects/kpgprimarykey.h"
#include "DbObjects/kpgindex.h"
#include "DbObjects/kpgrulesfolder.h"
#include "DbObjects/kpgrule.h"
#include "DbObjects/kpgtriggersfolder.h"
#include "DbObjects/kpgtrigger.h"

// Property pages includes
#include "PropertyPages/kpgvoidproppage.h"
#include "PropertyPages/kpgpropertypage.h"
#include "PropertyPages/kpgserverproppage.h"
#include "PropertyPages/kpgtablespaceproppage.h"
#include "PropertyPages/kpgdatabaseproppage.h"
#include "PropertyPages/kpgschemaproppage.h"
#include "PropertyPages/kpgtableproppage.h"
#include "PropertyPages/kpgviewproppage.h"
#include "PropertyPages/kpgtablecolumnproppage.h"
#include "PropertyPages/kpgprimarykeyconstrproppage.h"
#include "PropertyPages/kpgforeignkeyconstrproppage.h"
#include "PropertyPages/kpgcheckconstrproppage.h"
#include "PropertyPages/kpguniqueconstrproppage.h"
#include "PropertyPages/kpgprimarykeyproppage.h"
#include "PropertyPages/kpgindexproppage.h"
#include "PropertyPages/kpgruleproppage.h"
#include "PropertyPages/kpgtriggerproppage.h"
#include "PropertyPages/kpgfunctionproppage.h"
#include "PropertyPages/kpgsequenceproppage.h"
#include "PropertyPages/kpgoperatorproppage.h"
#include "PropertyPages/kpgoperatorclassproppage.h"
#include "PropertyPages/kpgaggregateproppage.h"
#include "PropertyPages/kpguserproppage.h"
#include "PropertyPages/kpggroupproppage.h"
#include "PropertyPages/kpgtypeproppage.h"
#include "PropertyPages/kpglanguageproppage.h"
#include "PropertyPages/kpgdomainproppage.h"
#include "PropertyPages/kpgconversionproppage.h"
#include "PropertyPages/kpgcastproppage.h"
#include "PropertyPages/kpgdomainconstrproppage.h"

// Wizards includes
#include "Wizards/kpgnewobjectdialog.h"
#include "Wizards/kpgdropobjectwizard.h"
#include "Wizards/kpg2stepswizard.h"
#include "Wizards/kpgrenameobjectwizard.h"
#include "Wizards/kpgcreatetablespacewizard.h"
#include "Wizards/kpgcreatedatabasewizard.h"
#include "Wizards/kpgcreateschemawizard.h"
#include "Wizards/kpgcreatetablewizard.h"
#include "Wizards/kpgcreateviewwizard.h"
#include "Wizards/kpgmodifyviewwizard.h"
#include "Wizards/kpgcreateuserwizard.h"
#include "Wizards/kpgmodifyuserwizard.h"
#include "Wizards/kpgcreategroupwizard.h"
#include "Wizards/kpgmodifygroupwizard.h"
#include "Wizards/kpgcreatelanguagewizard.h"
#include "Wizards/kpgcreatedomainwizard.h"
#include "Wizards/kpgcreatefunctionwizard.h"
#include "Wizards/kpgmodifyfunctionwizard.h"
#include "Wizards/kpgcreatesequencewizard.h"
#include "Wizards/kpgmodifysequencewizard.h"
#include "Wizards/kpgcreatetableconstraintwizard.h"
#include "Wizards/kpgcreatetableindexwizard.h"
#include "Wizards/kpgcreatetablecolumnwizard.h"
#include "Wizards/kpgmodifytablecolumnwizard.h"
#include "Wizards/kpgcreaterulewizard.h"
#include "Wizards/kpgcreatetriggerwizard.h"
#include "Wizards/kpganalysetablewizard.h"
#include "Wizards/kpgvacuumtablewizard.h"
#include "Wizards/kpgcopyfromtablewizard.h"
#include "Wizards/kpgcopytotablewizard.h"
#include "Wizards/kpgsetclustertablewizard.h"
#include "Wizards/kpgsetownerwizard.h"
#include "Wizards/kpgsettablespacewizard.h"
#include "Wizards/kpgsetdomaindefaultwizard.h"
#include "Wizards/kpgcreatedomainconstraintwizard.h"
#include "Wizards/kpgcreatebasetypewizard.h"
#include "Wizards/kpgcreatecompositetypewizard.h"

// Wizard pages includes
#include "Wizards/kpgmodifyviewwidget1.h"


KPoGreView::KPoGreView(QWidget *parent, const char *name) : QWidget(parent, name)
{
  setBackgroundMode(PaletteBase);
	 
	KPGTreeItem::m_pIconServer = new QPixmap(UserIcon("server.png"));
	
	KPGTreeItem::m_pIconTablespaceSys = new QPixmap(UserIcon("tblspace_sys.png"));
	KPGTreeItem::m_pIconTablespaceUsr = new QPixmap(UserIcon("tblspace_usr.png"));
	
	KPGTreeItem::m_pIconDatabase = new QPixmap(UserIcon("database.png"));
	KPGTreeItem::m_pIconDatabaseSys = new QPixmap(UserIcon("database_sys.png"));
	KPGTreeItem::m_pIconDatabaseUsr = new QPixmap(UserIcon("database_usr.png"));
		
	KPGTreeItem::m_pIconSchema = new QPixmap(UserIcon("schema.png"));
	KPGTreeItem::m_pIconSchemaSys = new QPixmap(UserIcon("schema_sys.png"));
	KPGTreeItem::m_pIconSchemaUsr = new QPixmap(UserIcon("schema_usr.png"));
		
  KPGTreeItem::m_pIconTable = new QPixmap(UserIcon("table.png"));
	KPGTreeItem::m_pIconFunction = new QPixmap(UserIcon("function.png"));
	KPGTreeItem::m_pIconFunctionC = new QPixmap(UserIcon("function_c.png"));
	KPGTreeItem::m_pIconFunctionSql = new QPixmap(UserIcon("function_sql.png"));
	KPGTreeItem::m_pIconFunctionPl = new QPixmap(UserIcon("function_pl.png"));
	KPGTreeItem::m_pIconView = new QPixmap(UserIcon("view.png"));
	KPGTreeItem::m_pIconSequence = new QPixmap(UserIcon("sequence.png"));
	KPGTreeItem::m_pIconOperator = new QPixmap(UserIcon("operator.png"));
	KPGTreeItem::m_pIconOperatorClass = new QPixmap(UserIcon("operator_class.png"));
	KPGTreeItem::m_pIconAggregate = new QPixmap(UserIcon("aggregate.png"));
	KPGTreeItem::m_pIconUser = new QPixmap(UserIcon("user.png"));
	KPGTreeItem::m_pIconUserSuper = new QPixmap(UserIcon("user_super.png"));
	KPGTreeItem::m_pIconUserCanCreateDb = new QPixmap(UserIcon("user_crt_db.png"));
	KPGTreeItem::m_pIconGroup = new QPixmap(UserIcon("group.png"));
	KPGTreeItem::m_pIconType = new QPixmap(UserIcon("type.png"));
	KPGTreeItem::m_pIconTypeBase = new QPixmap(UserIcon("type_base.png"));
	KPGTreeItem::m_pIconTypeComposite = new QPixmap(UserIcon("type_composite.png"));
	KPGTreeItem::m_pIconTypeStandalone = new QPixmap(UserIcon("type_standalone.png"));
	KPGTreeItem::m_pIconLanguage = new QPixmap(UserIcon("language.png"));
	KPGTreeItem::m_pIconDomain = new QPixmap(UserIcon("domain.png"));
	KPGTreeItem::m_pIconConversion = new QPixmap(UserIcon("conversion.png"));
	KPGTreeItem::m_pIconCast = new QPixmap(UserIcon("cast.png"));
	
	KPGTreeItem::m_pIconColumnOther = new QPixmap(UserIcon("column.png"));
	KPGTreeItem::m_pIconColumnBool = new QPixmap(UserIcon("column_bool.png"));
	KPGTreeItem::m_pIconColumnGeo = new QPixmap(UserIcon("column_geo.png"));   	
	KPGTreeItem::m_pIconColumnNet = new QPixmap(UserIcon("column_net.png"));
	KPGTreeItem::m_pIconColumnOid = new QPixmap(UserIcon("column_oid.png")); 
	KPGTreeItem::m_pIconColumnXid = new QPixmap(UserIcon("column_xid.png"));
	KPGTreeItem::m_pIconColumnTid = new QPixmap(UserIcon("column_tid.png"));
	KPGTreeItem::m_pIconColumnCid = new QPixmap(UserIcon("column_cid.png"));
	KPGTreeItem::m_pIconColumnDate = new QPixmap(UserIcon("column_date.png"));
	KPGTreeItem::m_pIconColumnChar = new QPixmap(UserIcon("column_char.png"));  
	KPGTreeItem::m_pIconColumnNum = new QPixmap(UserIcon("column_num.png"));
	KPGTreeItem::m_pIconColumnTime = new QPixmap(UserIcon("column_time.png"));
	KPGTreeItem::m_pIconColumnBit = new QPixmap(UserIcon("column_bit.png"));
	KPGTreeItem::m_pIconColumnBin = new QPixmap(UserIcon("column_bin.png"));
		 
	KPGTreeItem::m_pIconPrimaryKeyConstr = new QPixmap(UserIcon("primary_key.png"));
	KPGTreeItem::m_pIconForeignKeyConstr = new QPixmap(UserIcon("foreign_key.png"));
	KPGTreeItem::m_pIconUniqueConstr = new QPixmap(UserIcon("index.png"));
	KPGTreeItem::m_pIconCheckConstr = new QPixmap(UserIcon("check.png"));
	KPGTreeItem::m_pIconPrimaryKey = new QPixmap(UserIcon("primary_key.png"));
	KPGTreeItem::m_pIconIndex = new QPixmap(UserIcon("index.png"));
	KPGTreeItem::m_pIconRule = new QPixmap(UserIcon("rule.png"));
	KPGTreeItem::m_pIconTrigger = new QPixmap(UserIcon("trigger.png"));
	 
	KPGTreeItem::m_pIconFolderBlue = new QPixmap(SmallIcon("folder_blue.png"));
	KPGTreeItem::m_pIconFolderRed = new QPixmap(SmallIcon("folder_red.png"));
	KPGTreeItem::m_pIconFolderCyan = new QPixmap(SmallIcon("folder_cyan.png"));
	KPGTreeItem::m_pIconFolderGreen = new QPixmap(SmallIcon("folder_green.png"));
	KPGTreeItem::m_pIconFolderYellow = new QPixmap(SmallIcon("folder_yellow.png"));
	KPGTreeItem::m_pIconFolderViolet = new QPixmap(SmallIcon("folder_violet.png"));
	KPGTreeItem::m_pIconFolderGrey = new QPixmap(SmallIcon("folder_grey.png"));
	
		 	
  QVBoxLayout* pLayoutArea = new QVBoxLayout(this);
		
	//leftSplitter
	m_pSplitterleft = new QSplitter(Qt::Horizontal, this);
	
	// Left tree view
	m_pViewTree = new QListView(m_pSplitterleft);
	m_pViewTree->addColumn(i18n("Tree"));
	m_pViewTree->setRootIsDecorated(true);
	m_pViewTree->setAllColumnsShowFocus(true);
	m_pViewTree->setSortColumn(-1);

  connect(m_pViewTree, SIGNAL(rightButtonPressed(QListViewItem*, const QPoint&, int)), this, SLOT  (slotTreeViewRightButtonPressed(QListViewItem*, const QPoint&, int)) );
  connect( m_pViewTree, SIGNAL(selectionChanged()), this, SLOT(slotSelectionChanged()));

  m_pTabPropertiesAndTerminals = new QTabWidget(m_pSplitterleft);
  m_pWidgetProperties = 0;
  connect(m_pTabPropertiesAndTerminals, SIGNAL(currentChanged( QWidget * )), this, SLOT  (slotTabWidgetCurrentChanged( QWidget *)) );
	
  //construct 10 KPGSqlQueryResultWindow
	m_ppTerminals = new KPGSqlQueryResultWindow * [10];
	KPGSqlQueryResultWindow* pQueryResultWindow;
	for (int i=0 ; i<10 ; i++ )
  {
		QString tabString = "[";
		tabString.append( QString::number(i+1) );
		tabString.append("]");

    pQueryResultWindow = new KPGSqlQueryResultWindow( m_pTabPropertiesAndTerminals, tabString );
	  		
		m_ppTerminals[i] = pQueryResultWindow;
    m_pTabPropertiesAndTerminals->addTab(m_ppTerminals[i], QIconSet(SmallIcon("openterm")), tabString);
		
		connect( pQueryResultWindow, SIGNAL(sigRequestDatabasesList(KPGSqlQueryResultWindow *, const QString&)), this, SLOT(slotRequestDatabasesList(KPGSqlQueryResultWindow *, const QString&)));
		
		connect( pQueryResultWindow, SIGNAL(sigQueryTextChanged(KPGSqlQueryResultWindow *)), this, SLOT(slotQueryTextChanged(KPGSqlQueryResultWindow *)));
		
		connect( pQueryResultWindow, SIGNAL(sigCopyAvailable(KPGSqlQueryResultWindow *, bool)), this, SLOT(slotCopyAvailable(KPGSqlQueryResultWindow *, bool)));
		
		connect( pQueryResultWindow, SIGNAL(sigUndoAvailable(KPGSqlQueryResultWindow *, bool)), this, SLOT(slotUndoAvailable(KPGSqlQueryResultWindow *, bool)));
		
		connect( pQueryResultWindow, SIGNAL(sigRedoAvailable(KPGSqlQueryResultWindow *, bool)), this, SLOT(slotRedoAvailable(KPGSqlQueryResultWindow *, bool)));
	}
	    	
	//globalLayout
	QValueList<int> qvl;
	
	qvl.clear();
	qvl.append(170);
	qvl.append(620);
	m_pSplitterleft->setSizes(qvl);

	pLayoutArea->addWidget(m_pSplitterleft, 5);
}

KPoGreView::~KPoGreView()
{
}

/////////////////////////////////////////////////////////////////////
//                     PUBLIC FUNCTIONS
/////////////////////////////////////////////////////////////////////

KPoGreDoc *KPoGreView::getDocument() const
{
  KPoGreApp *theApp=(KPoGreApp *) parentWidget();

  return theApp->getDocument();
}

void KPoGreView::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}

void KPoGreView::setWaitCursor()
{
  parentWidget()->setCursor(KCursor::waitCursor());
  m_pViewTree->setCursor(KCursor::waitCursor());
}

void KPoGreView::setNormalCursor()
{
  parentWidget()->setCursor(KCursor::arrowCursor());
  m_pViewTree->setCursor(KCursor::arrowCursor());
}

// Set the given sql-string from an sqlfile on inputArea
void KPoGreView::setSQLText(const QString sqlText)
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::slotRunQuery terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->setText( sqlText );
}

// Return SQL test from input area
const QString KPoGreView::getSQLText() const
{
	int iSelectedTab = m_pTabPropertiesAndTerminals->currentPageIndex();
  if(iSelectedTab == 0)
  {
    kdError() << "pgServerKPoGreView::getSQLText terminal is not selected " << endl;
    return "";
  }

  return m_ppTerminals[iSelectedTab-1]->editQuery()->text();
}

// Return the currently selected result table (e.g. for saving the content to a file
	QTable* KPoGreView::getCurrentlySelectedTableResult()
{
  int iSelectedTab = m_pTabPropertiesAndTerminals->currentPageIndex();
  if(iSelectedTab == 0)
  {
    kdError() << "KPoGreView::getSQLText terminal is not selected " << endl;
    return 0;
  }
  
	return m_ppTerminals[iSelectedTab-1]->tableResult();	
}

/////////////////////////////////////////////////////////////////////
//                     PROTECTED FUNCTIONS
/////////////////////////////////////////////////////////////////////	

// Select given tree item
void KPoGreView::selectItem(KPGTreeItem * const pItem)
{
	if ( ! pItem  )
	{
		kdDebug() << "KPoGreView::selectItem: the given pointer is a null pointer" << endl;
		return;
	}

	m_pViewTree->setSelected( pItem, true );
	m_pViewTree->setCurrentItem( pItem );
	m_pViewTree->ensureItemVisible( pItem );
}

// Select item defined bu OID and path
KPGTreeItem* KPoGreView::findItem(const KPGOidLink & oidLink)
{
	QString strPath = oidLink.path();
	
	int iPos = strPath.find('/');
	if(iPos <= 0) return 0;

	QString strServer = strPath.mid(0, iPos);
	
	// search server
	QListViewItem * pItem = m_pViewTree->firstChild();
	while(pItem)
	{
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{
			KPGServer *pServer = static_cast <KPGServer *> (pItem);
			if(pServer->text(0) != strServer)
			{ pItem = pItem->nextSibling(); continue; }
				// remove server name from path
			QString strPath2 = strPath.mid(iPos + 1, strPath.length() - iPos - 1);
									
			//--- traverse list of databases
			KPGTreeItem * pItem2 = static_cast <KPGTreeItem *> (pServer->firstChild());
				
			while(pItem2)
			{
				KPGTreeItem * pFoundItem = 0;
				
				if((pFoundItem = pItem2->searchObject(strPath2, oidLink.oid())) != 0)
				{
					return pFoundItem;
				}
				pItem2 = static_cast <KPGTreeItem *> (pItem2->nextSibling());
			}
			pItem = pItem->nextSibling();
		}
	}

	return 0;
}

KPGDatabase * KPoGreView::lookUpParentDatabaseAndListOfSchemas(KPGTreeItem * pItem, QPtrList<QListViewItem> & listOfSchemas)
{
	KPGDatabase * pDatabase = 0;
	 
	if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeSchema)
		{
			pDatabase = static_cast <KPGDatabase *> (pItem->parent());
			listOfSchemas.append(static_cast <KPGSchema *> (pItem));
		}
		else
		{
			if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeDatabase)
			{
				pDatabase = static_cast <KPGDatabase *> (pItem);
				
				// Traverse Database childs and add schemas to combobox
				QListViewItem * pChildItem = pItem->firstChild();
				while(pChildItem)
				{			
					if((static_cast <KPGTreeItem *> (pChildItem))->type() == KPGTreeItem::nodeSchema)
					{
						listOfSchemas.append(static_cast <KPGSchema *> (pChildItem));
					}
		
					pChildItem = pChildItem->nextSibling();
				}
			}
		}
		
	return pDatabase;
}

void KPoGreView::refreshItemsFolder(KPGTreeItem * pItem, const QString & strFolderName)
{
	if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeSchema)
			{
				KPGItemsFolder *pItemsFolder = static_cast <KPGItemsFolder *> (pItem->getChildByName(strFolderName));
				pItemsFolder->refresh(); // refresh folder
			}
			else
			{
				if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeDatabase)
				{
					//KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pItem);
					
					// Traverse Database childs refresh schemas table folders
					QListViewItem * pChildItem = pItem->firstChild();
					while(pChildItem)
					{			
						if((static_cast <KPGTreeItem *> (pChildItem))->type() == KPGTreeItem::nodeSchema)
						{
						  KPGSchema *pSchema = static_cast <KPGSchema *> (pChildItem);	
              
              KPGItemsFolder *pItemsFolder = static_cast <KPGItemsFolder *> (pSchema->getChildByName(strFolderName));
							if(!pItemsFolder)
              {
                kdDebug() << "KPoGreView::refreshItemsFolder: getChildByName return null pointer for " << strFolderName << endl;
                return;
              }
              pItemsFolder->refresh(); // refresh all schemas tables folder under database
						}
			
						pChildItem = pChildItem->nextSibling();
					}
				}
			}
}

// Create Properties tab, with regards to selected type in tree
void KPoGreView::createPropertiesTab(const KPGTreeItem::eNodeType nodeType)
{
  // delete old widget property page
  if(m_pWidgetProperties)
  {
    disconnect(m_pWidgetProperties, SIGNAL(sigSearchObject(const pqxx::oid)), this, SLOT( slotSearchObject(const pqxx::oid)));
				
		if(m_pWidgetProperties->className() == "KPGSchemaPropPage")
		{
			disconnect(m_pWidgetProperties, SIGNAL(sigCurrentTabChanged(KPGSchemaPropPage *, QWidget *)), this, SLOT(slotSchemaPropTabChanged(KPGSchemaPropPage *, QWidget *)));	
		}
		
		// Disconnect to avoid fire slotTabWidgetCurrentChanged as result to removePage, because this call this function 
		disconnect(m_pTabPropertiesAndTerminals, SIGNAL(currentChanged( QWidget * )), this, SLOT  (slotTabWidgetCurrentChanged( QWidget *)) );
		
		m_pTabPropertiesAndTerminals->removePage(m_pWidgetProperties);
    m_pWidgetProperties = 0;
		
		// And reconnect now
		connect(m_pTabPropertiesAndTerminals, SIGNAL(currentChanged( QWidget * )), this, SLOT  (slotTabWidgetCurrentChanged( QWidget *)) );
		
		if(nodeType == KPGTreeItem::nodeUnselected)
			return;
  }
  
  // create new property page
  switch(nodeType)
      {
				//******************************************************************************************
				//
				// Main objects
				//
				//******************************************************************************************
				
        case KPGTreeItem::nodeServer:
          m_pWidgetProperties = new KPGServerPropPage(m_pTabPropertiesAndTerminals);  
          break;

        case KPGTreeItem::nodeDatabase:
          m_pWidgetProperties = new KPGDatabasePropPage(m_pTabPropertiesAndTerminals);
          break;
        				
				case KPGTreeItem::nodeSchema:
          m_pWidgetProperties = new KPGSchemaPropPage(m_pTabPropertiesAndTerminals);
					connect(m_pWidgetProperties, SIGNAL(sigCurrentTabChanged(KPGSchemaPropPage *, QWidget *)), this, SLOT(slotSchemaPropTabChanged(KPGSchemaPropPage *, QWidget *)));
          break;
				
				case KPGTreeItem::nodeFolderGroups:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeFolderUsers:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderTablespaces:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeUser:
          m_pWidgetProperties = new KPGUserPropPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeGroup:
          m_pWidgetProperties = new KPGGroupPropPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeTablespace:
          m_pWidgetProperties = new KPGTablespacePropPage(m_pTabPropertiesAndTerminals);
          break;
									
				//******************************************************************************************
				//
				// Database objects folders
				//
				//******************************************************************************************
										
				case KPGTreeItem::nodeFolderTables:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeFolderViews:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderSequences:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderFunctions:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderOperators:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderOperatorClasses:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderAggregates:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
											
				case KPGTreeItem::nodeFolderTypes:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderLanguages: 
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderDomains:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderConversions:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderCasts:
          m_pWidgetProperties = new KPGPropertyPage(m_pTabPropertiesAndTerminals);
          break;		
				
				
				//******************************************************************************************
				//
				// Database objects
				//
				//******************************************************************************************
				
				case KPGTreeItem::nodeTable:
          m_pWidgetProperties = new KPGTablePropPage(m_pTabPropertiesAndTerminals);
          break;

        case KPGTreeItem::nodeView:
          m_pWidgetProperties = new KPGViewPropPage(m_pTabPropertiesAndTerminals);	
          break;
					
				case KPGTreeItem::nodeSequence:
          m_pWidgetProperties = new KPGSequencePropPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFunction:
          m_pWidgetProperties = new KPGFunctionPropPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeOperator:
          m_pWidgetProperties = new KPGOperatorPropPage(m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeOperatorClass:
          m_pWidgetProperties = new KPGOperatorClassPropPage(m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeAggregate:
          m_pWidgetProperties = new KPGAggregatePropPage(m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeType:
					m_pWidgetProperties = new KPGTypePropPage( m_pTabPropertiesAndTerminals);
          break;
				
				case KPGTreeItem::nodeLanguage:
					m_pWidgetProperties = new KPGLanguagePropPage( m_pTabPropertiesAndTerminals);
          break; 
				
				case KPGTreeItem::nodeDomain:
					m_pWidgetProperties = new KPGDomainPropPage( m_pTabPropertiesAndTerminals);
          break; 
				
				case KPGTreeItem::nodeConversion:
					m_pWidgetProperties = new KPGConversionPropPage( m_pTabPropertiesAndTerminals);
          break; 
				
				case KPGTreeItem::nodeCast:
					m_pWidgetProperties = new KPGCastPropPage( m_pTabPropertiesAndTerminals);
          break;			
					
				//******************************************************************************************
				//
				// Table objects folders
				//
				//******************************************************************************************
				
						
				case KPGTreeItem::nodeFolderTableColumns:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderTableConstraints:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderTableIndexes:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderRules:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeFolderTriggers:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
        
        // Domain objects folders
            
        case KPGTreeItem::nodeFolderDomainConstraints:
          m_pWidgetProperties = new KPGPropertyPage( m_pTabPropertiesAndTerminals);
          break;
					
				//******************************************************************************************
				//
				// Table objects
				//
				//******************************************************************************************
									
				case KPGTreeItem::nodeTableColumn:
          m_pWidgetProperties = new KPGTableColumnPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodePrimaryKeyConstr:
          m_pWidgetProperties = new KPGPrimaryKeyConstrPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeForeignKeyConstr:
          m_pWidgetProperties = new KPGForeignKeyConstrPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeUniqueConstr:
          m_pWidgetProperties = new KPGUniqueConstrPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeCheckConstr:
          m_pWidgetProperties = new KPGCheckConstrPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodePrimaryKey:
          m_pWidgetProperties = new KPGPrimaryKeyPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeIndex:
          m_pWidgetProperties = new KPGIndexPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeRule:
          m_pWidgetProperties = new KPGRulePropPage( m_pTabPropertiesAndTerminals);
          break;
					
				case KPGTreeItem::nodeTrigger:
          m_pWidgetProperties = new KPGTriggerPropPage( m_pTabPropertiesAndTerminals);
          break;
          
        // Domain object
        case KPGTreeItem::nodeDomainConstr:
          m_pWidgetProperties = new KPGDomainConstrPropPage( m_pTabPropertiesAndTerminals);
          break;
					
				//******************************************************************************************
				//
				// Unselected or unknown
				//
				//******************************************************************************************
					

        case KPGTreeItem::nodeUnselected:
          break;
					
			  default:
					m_pWidgetProperties = new KPGVoidPropPage(m_pTabPropertiesAndTerminals);
          break;
      } 
  
  if(m_pWidgetProperties)
    { m_pTabPropertiesAndTerminals->insertTab(m_pWidgetProperties, QIconSet(SmallIcon("history")), i18n("Properties"), 0);
      m_pTabPropertiesAndTerminals->setCurrentPage(0);
			connect(m_pWidgetProperties, SIGNAL(sigSearchObject(const pqxx::oid)), this, SLOT( slotSearchObject(const pqxx::oid)));   
    }
}

// Send SQL query to server
void KPoGreView::runQuery(const QString& strQuery)
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::slotRunQuery terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	
	// clear previous result
	pQueryResultWindow->m_pTableResult->setNumRows(0);
  pQueryResultWindow->m_pTableResult->setNumCols(0);
	pQueryResultWindow->m_pTextEditResult->clear();
		
	// get selected server and database
	QString strServer(pQueryResultWindow->m_pComboBoxServer->currentText());
	QString strDatabase(pQueryResultWindow->m_pComboBoxDatabase->currentText());
	
	int iTransType = pQueryResultWindow->m_pComboBoxTransaction->currentItem();
	KPGConnection::eTransType transType;
	switch(iTransType)
	{
		case 0: transType = KPGConnection::eTransNormal;
		 				break;
						
		case 1: transType = KPGConnection::eTransRobust;
						break;
						
		case 2: transType = KPGConnection::eTransNone;
						break;
	}
		
	if(strServer.length() == 0)
	{
    kdError() << "KPoGreView::runQuery - server selected " << endl;
    return;
  }
		
	if(strDatabase.length() == 0)
	{
    kdError() << "KPoGreView::runQuery - database is not selected " << endl;
    return;
  }
	
	// search selected server and database
	QListViewItem * pItem = m_pViewTree->firstChild();
	while(pItem)
	{
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{
			KPGServer *pServer = static_cast <KPGServer *> (pItem);
			if(pServer->text(0) != strServer)
			{ 
				pItem = pItem->nextSibling(); continue; }
									
				//--- traverse list of connected databases
				QListViewItem * pItem2 = pServer->firstChild();
				
				while(pItem2)
				{
					if((static_cast <KPGTreeItem *> (pItem2))->type() == KPGTreeItem::nodeDatabase)
					{
						KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pItem2);
						if(pDatabase->text(0) != strDatabase)
							{ 
								pItem2 = pItem2->nextSibling(); continue; 
							}
				
						if(pDatabase->connection())
						{ 
							// run query on selected database
							pqxx::result pqxxResult;  
							try
							{
								pqxxResult = pDatabase->runQuery(strQuery, transType);
							}
							catch (const std::exception &e)
							{
								KMessageBox::sorry(this, e.what());
								return ;
							} 
							
							// display result
							if(pqxxResult.size() > 0)
							{
								displayResult(pqxxResult, pQueryResultWindow->m_pTableResult, pDatabase->encoderName()); 
								emit sigEnableFileActions(true, pQueryResultWindow->queryTextChanged(), !pQueryResultWindow->resultEmpty());
								pQueryResultWindow->widgetStackResults->raiseWidget(0);
							}
							else
							{
								if(pDatabase->connection()->notifications().count() > 0)
									{
										pQueryResultWindow->m_pTextEditResult->setText(pDatabase->connection()->notifications().join(""));
										pDatabase->connection()->clearNotifications();
									}
								else	
									pQueryResultWindow->m_pTextEditResult->setText(i18n("Operation successfull"));
									
								pQueryResultWindow->widgetStackResults->raiseWidget(1);
							}						
						}
						else
						{
							kdError() << "KPoGreView::runQuery - database is disconected " << endl;
							return;
						}
					}			
					pItem2 = pItem2->nextSibling();
				}	 
			}
			pItem = pItem->nextSibling();
		}
}

// Display SQL result
void KPoGreView::displayResult(pqxx::result pqxxResult, QTable* pTableResult, const QString& strEncoderName)
{
	// Fill output area with query result
  int nRows = pqxxResult.size();
  int nCols = pqxxResult.columns();
  
  pTableResult->setNumRows(nRows);
  pTableResult->setNumCols(nCols);

  // field names
  QHeader* hHeader = pTableResult->horizontalHeader();

  for(int nCol = 0; nCol < nCols; nCol++)
  {
    hHeader->setLabel(nCol, pqxxResult.column_name(nCol));
  }
  
	QTextCodec *pTextCodec = QTextCodec::codecForName(strEncoderName);
	if(!pTextCodec)
		pTextCodec = QTextCodec::codecForLocale(); // hope that correct codec is returned
	 
  // data
  for(int nRow = 0; nRow < nRows; nRow++)
  {
    for(int nCol = 0; nCol < nCols; nCol++)
    {
      QString strValue(pTextCodec->toUnicode(pqxxResult[nRow][nCol].c_str()));
      pTableResult->setText(nRow, nCol, strValue);
    }
  }

  for(int nCol = 0; nCol < nCols; nCol++)
  {
    pTableResult->adjustColumn(nCol);
  }
}

// Walk through m_pViewTree items
KPGTreeItem * KPoGreView::nextTreeItem(const KPGTreeItem *pItem)
{
	if(pItem == 0)
	{
		kdDebug() << "KPoGreView::nextTreeItem - the given item is null" << endl;
		return 0;
	}
	
	// checking for a child
	if ( ! pItem->firstChild() == 0 )
		return static_cast <KPGTreeItem *> (pItem->firstChild());

	// there is no child -> checking for the next sibling
	if ( ! pItem->nextSibling() == 0 )
		return static_cast <KPGTreeItem *> (pItem->nextSibling());

	// there is no next sibling -> checking for parents' next sibling(s)
	KPGTreeItem *pItemParent = static_cast <KPGTreeItem *> (pItem->parent());
	while ( ! pItemParent == 0 )
	{
		if ( ! pItemParent->nextSibling() == 0 )
			return static_cast <KPGTreeItem *> (pItemParent->nextSibling());

		pItemParent = static_cast <KPGTreeItem *> (pItemParent->parent()); // parent has no sibling - try its parent
	}

	// parent has no parents anymore
	return 0;
}

/////////////////////////////////////////////////////////////////////
//                     ACTION FUNCTIONS
/////////////////////////////////////////////////////////////////////

// Called when user choose bookmark
void KPoGreView::openUrl(const QString& strUrl)
{
    
  QString strHost;
  QString strPort;
  QString strUser;
  QString strDatabase;
  
  int pos = 0;        
  
  // find host name in URL
  QRegExp patternHost("host=\\S*[\\s,]", false); // search keyword
               
  pos=patternHost.search(strUrl, 0);
  if(pos >= 0)
  {
    int l = patternHost.matchedLength();
    strHost = strUrl.mid(pos + 5, l - 6);
  } 
  else
    KMessageBox::sorry(this, "Cannot parse URL");
  
  // find port number in URL
  QRegExp patternPort("port=\\S*[\\s,]", false); // search keyword
               
  pos=patternPort.search(strUrl, 0);
  if(pos >= 0)
  {
    int l = patternPort.matchedLength();
    strPort = strUrl.mid(pos + 5, l - 6);
  } 
  else
    KMessageBox::sorry(this, "Cannot parse URL");
  
  // find user name in URL
  QRegExp patternUser("user=\\S*", false); // search keyword
               
  pos=patternUser.search(strUrl, 0);
  if(pos >= 0)
  {
    int l = patternUser.matchedLength();
    strUser = strUrl.mid(pos + 5, l - 5);
  }
  else
    KMessageBox::sorry(this, "Cannot parse URL");
    
  // find database name in URL
  QRegExp patternDatabase("dbname=\\S*", false); // search keyword
               
  pos=patternDatabase.search(strUrl, 0);
  if(pos >= 0)
  {
    int l = patternDatabase.matchedLength();
    strDatabase = strUrl.mid(pos + 7, l - 7);
  }
  else
    KMessageBox::sorry(this, "Cannot parse URL");
    
  
  // display connect dialog
  KPGConnectDialog dlg( this, "connect dialog" );
  dlg.setHostName(strHost);
  dlg.setUserName(strUser);
  dlg.setPortNumber(strPort);
  dlg.setDatabaseName(strDatabase);
  dlg.setGui();
	if( dlg.exec() != QDialog::Accepted )
    {
      return;
    }
	
	//--- check if server is already connected
	QListViewItem * pItem = m_pViewTree->firstChild();
	while(pItem)
	{
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{
			KPGServer *pServer = static_cast <KPGServer *> (pItem);
			if(pServer->text(0) == dlg.hostName())
				{ 
					KMessageBox::sorry(this, i18n("Server is already connected"));
					return;
				}	
		  pItem = pItem->nextSibling();
		}
	}	
		
  KPGServer *pgServer = new KPGServer(m_pViewTree);
  bool bConnected = pgServer->connectToServer(dlg.hostName(), dlg.portNumber(), dlg.databaseName(), dlg.userName(), dlg.password());
  if(!bConnected)
    delete pgServer; // delete unsucessfull connection  
}

// Connect to PostgreSQL server
void KPoGreView::databaseConnect()
{
  KPGConnectDialog dlg( this, "connect dialog" );
	if( dlg.exec() != QDialog::Accepted )
  {
    return;
  }
		
	//--- check if server is already connected
	QListViewItem * pItem = m_pViewTree->firstChild();
	while(pItem)
	{
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{
			KPGServer *pServer = static_cast <KPGServer *> (pItem);
			
			if(pServer->text(0) == dlg.hostName())
				{ 
					KMessageBox::sorry(this, i18n("Server is already connected"));
					return;		
				}	
		  pItem = pItem->nextSibling();
		}
	}
	
	
  KPGServer *pgServer = new KPGServer(m_pViewTree);
  bool bConnected = pgServer->connectToServer(dlg.hostName(), dlg.portNumber(), dlg.databaseName(), dlg.userName(), dlg.password());
  
	if(!bConnected)
    delete pgServer; // delete unsucessfull connection
}

// Disconnect from selected server
void KPoGreView::databaseDisconnect()
{

  KPGTreeItem * pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(pItem )
  {
    if(pItem->type() != KPGTreeItem::nodeServer)
      return;
          
    QString question = "Disconnect from ";
		question.append(pItem->text(0));
		question.append(" ?");
		if( KMessageBox::questionYesNo(this, question, "question") == KMessageBox::Yes )
      {
          delete pItem;
      }
  }  
}

// Send text from selected Inputarea to server
void KPoGreView::databaseRunQuery()
{
  int iSelectedTab = m_pTabPropertiesAndTerminals->currentPageIndex();
  if(m_pWidgetProperties)
    iSelectedTab--; // properties widget is exists at first tab position
  // TODO: add this workaround to all similar code  
	runQuery(m_ppTerminals[iSelectedTab]->editQuery()->text());
}

void KPoGreView::databaseWizard()
{
	KPGTreeItem * pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(!pItem) return;
	
	//---------------------------------------------------------------------------------
	KPGNewObjectDialog::eNewObjectIconSet eIconSet; // icon set for dialog
	QString strCaption;
	bool bTablespces = false;
   
	if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{ 
      if((static_cast <KPGServer *> (pItem))->versionMajor() >= 8) 
        bTablespces = true;
        
      eIconSet = KPGNewObjectDialog::iconSetServer;
			strCaption = i18n("New server object");
		}
	else
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeDatabase)
	 	{
				eIconSet = KPGNewObjectDialog::iconSetDatabase; 
				strCaption = i18n("New database object");
		}
		else
			{
        if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeSchema)
        {
          eIconSet = KPGNewObjectDialog::iconSetSchema; 
          strCaption = i18n("New schema object");
        } 
        else
          {
            if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeTable)
            {
              eIconSet = KPGNewObjectDialog::iconSetTable; 
              strCaption = i18n("New table object");
            }         
            else 
              return;
          }
	   }
     
	KPGNewObjectDialog dlg(this, "KPGNewObjectDialog", eIconSet, strCaption, bTablespces);
	if(dlg.exec() != QDialog::Accepted)
  	return;
	
  //******************************************************************************************
  //
  // Main objects
  //
  //******************************************************************************************
          
	if(dlg.objectType() == "database")
	{
		if(createDatabaseWizard(static_cast <KPGServer *> (pItem)))
			pItem->refresh();
		
		return;
	}
		
  if(dlg.objectType() == "tablespace")
  {
    if(createTablespaceWizard(static_cast <KPGServer *> (pItem)))
    {
      setWaitCursor();
      KPGItemsFolder *pFolder = (static_cast <KPGServer *> (pItem))->getTablespacesFolder();
      pFolder->refresh();
      setNormalCursor();
    }
    return;
  }
  
	if(dlg.objectType() == "group")
	{
		if(createGroupWizard(static_cast <KPGServer *> (pItem)))
		{
			setWaitCursor();
			KPGItemsFolder *pFolder = (static_cast <KPGServer *> (pItem))->getGroupsFolder();
			pFolder->refresh();
			setNormalCursor();
		}
		return;
	}
	
	if(dlg.objectType() == "user")
	{
		if(createUserWizard(static_cast <KPGServer *> (pItem)))
		{
			setWaitCursor();
			KPGItemsFolder *pFolder = (static_cast <KPGServer *> (pItem))->getUsersFolder();
			pFolder->refresh();
			setNormalCursor();
		}
		return;
	}

  //******************************************************************************************
  //
  // Database objects
  //
  //******************************************************************************************
        
	if(dlg.objectType() == "schema")
	{
		if(createSchemaWizard(static_cast <KPGDatabase *> (pItem)))
		{
			setWaitCursor();
			pItem->refresh();
			setNormalCursor();
		}
		return;
	}
  
  if(dlg.objectType() == "language")
  {
    if(createLanguageWizard(static_cast <KPGDatabase *> (pItem)))
    {
      setWaitCursor();
      KPGItemsFolder *pFolder = (static_cast <KPGDatabase *> (pItem))->getLanguagesFolder();
      pFolder->refresh();
      setNormalCursor();
    }
    return;
  }
		
	if(dlg.objectType() == "table")
	{
		// Setup namespace(s) and find connection
		QPtrList<QListViewItem> listOfSchemas;
		KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
					
		if(createTableWizard(pDatabase, listOfSchemas))
			refreshItemsFolder(pItem, i18n("Tables"));
			
		return;
	}
  
  if(dlg.objectType() == "base type")
  {
    // Setup namespace(s) and find connection
    QPtrList<QListViewItem> listOfSchemas;
    KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
          
    if(createBaseTypeWizard(pDatabase, listOfSchemas))
      refreshItemsFolder(pItem, i18n("Types"));
      
    return;
  }
  
  if(dlg.objectType() == "composite type")
  {
    // Setup namespace(s) and find connection
    QPtrList<QListViewItem> listOfSchemas;
    KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
          
    if(createCompositeTypeWizard(pDatabase, listOfSchemas))
      refreshItemsFolder(pItem, i18n("Types"));
      
    return;
  }
	
	if(dlg.objectType() == "view")
	{
		// Setup namespace(s) and find connection
		QPtrList<QListViewItem> listOfSchemas;
		KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
					
		if(createViewWizard(pDatabase, listOfSchemas))
			refreshItemsFolder(pItem, i18n("Views"));
			
		return;
	}
	
  if(dlg.objectType() == "function")
  {
    // Setup namespace(s) and find connection
    QPtrList<QListViewItem> listOfSchemas;
    KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
          
    if(createFunctionWizard(pDatabase, listOfSchemas))
      refreshItemsFolder(pItem, i18n("Functions"));
      
    return;
  }
  
  if(dlg.objectType() == "domain")
  {
    // Setup namespace(s) and find connection
    QPtrList<QListViewItem> listOfSchemas;
    KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
          
    if(createDomainWizard(pDatabase, listOfSchemas))
      refreshItemsFolder(pItem, i18n("Domains"));
      
    return;
  }
	
	if(dlg.objectType() == "sequence")
  {
    // Setup namespace(s) and find connection
    QPtrList<QListViewItem> listOfSchemas;
    KPGDatabase *pDatabase = lookUpParentDatabaseAndListOfSchemas(pItem, listOfSchemas);
          
    if(createSequenceWizard(pDatabase, listOfSchemas))
      refreshItemsFolder(pItem, i18n("Sequences"));
      
    return;
  }
  
  //******************************************************************************************
  //
  // Table objects
  //
  //******************************************************************************************

  if(dlg.objectType() == "column")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createColumnWizard(pDatabase, pSchema, pTable))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }     
  
  if(dlg.objectType() == "primary key")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(pTable->primaryKeyName().isEmpty() == false)
    {
      KMessageBox::sorry(this, i18n("Primary key already exists !"));
      return;   
    }
           
    if(createConstraintWizard(pDatabase, pSchema, pTable, 0))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  } 
  
  if(dlg.objectType() == "foreign key")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createConstraintWizard(pDatabase, pSchema, pTable, 1))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }
  
  if(dlg.objectType() == "unique")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createConstraintWizard(pDatabase, pSchema, pTable, 2))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }
  
  if(dlg.objectType() == "check")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createConstraintWizard(pDatabase, pSchema, pTable, 3))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }
  
  if(dlg.objectType() == "index")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createIndexWizard(pDatabase, pSchema, pTable))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }
	
	if(dlg.objectType() == "rule")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createRuleWizard(pDatabase, pSchema, pTable))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }
	
	if(dlg.objectType() == "trigger")
  {
    KPGTable *pTable = static_cast <KPGTable *> (pItem);
    KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
    KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
    if(createTriggerWizard(pDatabase, pSchema, pTable))
      {
        setWaitCursor();
        static_cast <KPGTableItemsFolder *> (pTable->getTableConstraintsFolder())->refresh();
        setNormalCursor();
      }
  }       
}

// Called when user launch Find or Find Next menu item 
void KPoGreView::editFind(const QString &strSearchString, bool bInOIDs, bool bInNames)
{
	// Start find from current item or from first item - if no selected
	KPGTreeItem *pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pItem)
		{
		  pItem = static_cast <KPGTreeItem *> (m_pViewTree->firstChild());
			
			if(!pItem)
			{ 
				KMessageBox::sorry(this, i18n("No server is connected"));
				kdError() << "KPoGreView::editFind item is not selected " << endl;
				return;    
			}
		}
	else
		pItem = nextTreeItem(pItem);
	
			
	//--- Search item ---------------------------------
	while(pItem)
	{
		if(bInNames && (pItem->text(0) == strSearchString)) 
		{
			selectItem(pItem);
			return;
		}
		
		if(bInOIDs && (pItem->hasOid()))
		{
			KPGObject *pObject = static_cast <KPGObject *> (pItem);
			QString strOid(QString("%1").arg(pObject->oid()));
			
			if(strOid == strSearchString)
			{
				selectItem(pItem);
				return;
			}
		}
		
		pItem = nextTreeItem(pItem);
	}
	
	KMessageBox::sorry(this, i18n("Searched item not found"));
}

void KPoGreView::editUndo()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editUndo terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->undo();
}

void KPoGreView::editRedo()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editRedo terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->redo();
}

void KPoGreView::editCut()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editCut terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->cut();
}

void KPoGreView::editCopy()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editCopy terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->copy();
}

void KPoGreView::editPaste()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editPaste terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->paste();
}

// Clear inputarea
void KPoGreView::editClearInputArea()
{
	// get current SQL query result window
	QWidget *pCurrentPage = m_pTabPropertiesAndTerminals->currentPage();
	if(pCurrentPage == m_pWidgetProperties)
  {
    kdError() << "KPoGreView::editClearInputArea terminal is not selected " << endl;
    return;
  }
	
	KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pCurrentPage);
	pQueryResultWindow->editQuery()->clear();
}

// Deselects currently selected item
void KPoGreView::editDeselect()
{
	m_pViewTree->clearSelection();
}


void KPoGreView::viewNodeUp()
{
	// Start find from current item or from first item - if no selected
	KPGTreeItem *pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pItem)
		{
		  kdError() << "KPoGreView::viewNodeUp not current item " << endl;
			return; 
		}
		
	KPGTreeItem *pParentItem = static_cast <KPGTreeItem *> (pItem->parent());
	if(pParentItem)
		selectItem(pParentItem);
}

void KPoGreView::viewNodeBack()
{
	// Start find from current items parent server
	KPGTreeItem *pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pSelectedItem)
		{
		  KMessageBox::sorry(this, i18n("No item selected "));
			kdError() << "KPoGreView::viewNodeBack - item is not selected " << endl;
			return;    
		}
	
	KPGOidLink oidLink = m_stackBackNodes.pop();	
	KPGTreeItem *pItem = findItem(oidLink);
	if(!pItem) return;
	
			
	// store info about previously selected item to stack
	if((pSelectedItem->hasOid()))
	{
		KPGObject *pOldObject = static_cast <KPGObject *> (pSelectedItem);
			
		m_stackForwardNodes.push(KPGOidLink(pOldObject->oid(), pOldObject->path()));
	}
	else
		m_stackForwardNodes.push(KPGOidLink(0, pSelectedItem->path()));
		
	selectItem(pItem);
}
	
void KPoGreView::viewNodeForward()
{
	// Start find from current items parent server
	KPGTreeItem *pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pSelectedItem)
		{
		  KMessageBox::sorry(this, i18n("No item selected "));
			kdError() << "KPoGreView::viewNodeForward - item is not selected " << endl;
			return;    
		}
	
	KPGOidLink oidLink = m_stackForwardNodes.pop();
	KPGTreeItem *pItem = findItem(oidLink);
	if(!pItem) return;
		
	// store info about previously selected item to stack
	if((pSelectedItem->hasOid()))
	{
		KPGObject *pOldObject = static_cast <KPGObject *> (pSelectedItem);
				
		m_stackBackNodes.push(KPGOidLink(pOldObject->oid(), pOldObject->path()));
	}
	else
		m_stackBackNodes.push(KPGOidLink(0, pSelectedItem->path()));
		
	selectItem(pItem);
}

// Refresh actually selected tree item
void KPoGreView::refresh()
{
	KPGTreeItem * pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pItem)
		{ 
		  kdError() << "KPoGreView::refresh item is not selected " << endl;
			return;    
    }
	
	setWaitCursor();	
	pItem->smartRefresh();
	setNormalCursor();
}

// Select item in tree view by given path 
bool KPoGreView::selectItemByPath(const QString &strPath)
{
	// find host name in URL
  QRegExp patternOid("[[]\\d+[]]$", false); // search OID in path - server/namespace/database/.../object[nnnn]
 
	QString strPathWithoutOid(strPath);
	pqxx::oid _oid = 0;
	              
  int pos = patternOid.search(strPath, 0);
  if(pos > 0)
  {
    int l = patternOid.matchedLength();
    QString strOid(strPath.mid(pos + 1, l - 2));
		_oid = strOid.toInt();
		
		strPathWithoutOid = strPath.left(strPath.length() - l);
  }
		
	KPGTreeItem *pItem = findItem(KPGOidLink(_oid, strPathWithoutOid));
	if(!pItem) return false;
		
	selectItem(pItem);
	return true;
}	

/////////////////////////////////////////////////////////////////////
//                   WIZARD ACTION FUNCTIONS
/////////////////////////////////////////////////////////////////////

// Run Create Database Wizard 
void KPoGreView::createDatabase()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createDatabase: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeServer)
	{
		kdDebug() << "KPoGreView::createDatabase: item types mismatch" << endl;
		return;
	}
	
	KPGServer *pServer = static_cast <KPGServer *> (pSelectedItem);
	
	if(createDatabaseWizard(pServer))
		pServer->smartRefresh();
}

// Run Drop Database Wizard 
void KPoGreView::dropDatabase()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropDatabase: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
	{
		kdDebug() << "KPoGreView::dropDatabase: item types mismatch" << endl;
		return;
	}
	
	// Disconnect deleted database
	KPGDatabase *pDatabase  = static_cast <KPGDatabase *> (pSelectedItem);
	pDatabase->disconnectFromDB();
	
	// Run Wizard
	QString strSQL("DROP DATABASE ");
	strSQL.append(pSelectedItem->text(0));
	strSQL.append(";");
	
	KPGServer *pServer = static_cast <KPGServer *> (pSelectedItem->parent());
	KPG2StepsWizard wzd(this, "Drop database", strSQL, false);
  wzd.setConnection(pServer->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
  
	// Refresh parent item
	setWaitCursor();
	pServer->smartRefresh();
	setNormalCursor();
}

// Run ANALYSE Wizard
void KPoGreView::analyseDatabase()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::analyseDatabase: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
  {
    kdDebug() << "KPoGreView::analyseDatabase: item types mismatch" << endl;
    return;
  }
  
  KPGDatabase *pDatabase  = static_cast <KPGDatabase *> (pSelectedItem);
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", "ANALYZE VERBOSE;", true);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run REINDEX DATABASE
void KPoGreView::reindexDatabase()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::reindexDatabase: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
  {
    kdDebug() << "KPoGreView::reindexDatabase: item types mismatch" << endl;
    return;
  }
  
  KPGDatabase *pDatabase  = static_cast <KPGDatabase *> (pSelectedItem);
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", "REINDEX DATABASE " + pDatabase->text(0) + ";", false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run ALTER DATABASE name OWNER TO new_owner Wizard
void KPoGreView::setOwnerDatabase()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerDatabase: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
  {
    kdDebug() << "KPoGreView::setOwnerDatabase: item types mismatch" << endl;
    return;
  }
  
  KPGDatabase *pDatabase  = static_cast <KPGDatabase *> (pSelectedItem);
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
    
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "DATABASE", pDatabase->text(0), pDatabase->owner());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
     
  setWaitCursor();
  pDatabase->refreshItem();
  pDatabase->displayProperties(m_pWidgetProperties);
  setNormalCursor();
}

// Close connection to database
void KPoGreView::disconnectDatabase()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::disconnectDatabase: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
  {
    kdDebug() << "KPoGreView::disconnectDatabase: item types mismatch" << endl;
    return;
  }
  
  // Disconnect deleted database
  KPGDatabase *pDatabase  = static_cast <KPGDatabase *> (pSelectedItem);
  pDatabase->disconnectFromDB();
}

// Run Create Schema Wizard 
void KPoGreView::createSchema()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createSchema: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDatabase)
	{
		kdDebug() << "KPoGreView::createSchema: item types mismatch" << endl;
		return;
	}
	
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSelectedItem);
		
	if(createSchemaWizard(pDatabase))
		refresh();
}

// Run Drop Schema Wizard 
void KPoGreView::dropSchema()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropSchema: no item selected" << endl;
		return;
	}
		
	KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem);
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	dropObjectWizard(pSelectedItem, KPGTreeItem::nodeSchema, "SCHEMA", pDatabase->connection(), "");
}

// Run Create Schema Wizard 
void KPoGreView::modifySchema()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::modifySchema: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeSchema)
  {
    kdDebug() << "KPoGreView::modifySchema: item types mismatch" << endl;
    return;
  }

  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem);
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", pSchema->text(0), "SCHEMA", i18n("schema"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pDatabase->refresh();
  setNormalCursor();
}

// Run ALTER Schema OWNER TO new_owner Wizard 
void KPoGreView::setOwnerSchema()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerSchema: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeSchema)
  {
    kdDebug() << "KPoGreView::setOwnerSchema: item types mismatch" << endl;
    return;
  }

  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem);
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
  
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "SCHEMA", pSchema->text(0), pSchema->owner());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pSchema->refreshItem();
  pSchema->displayProperties(m_pWidgetProperties);
  setNormalCursor();
}

// Run Create Table Wizard 
void KPoGreView::createTable()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createTable: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTables)
	{
		kdDebug() << "KPoGreView::createTable: item types mismatch" << endl;
		return;
	}
	
	KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	QPtrList<QListViewItem> listOfSchemas;
	listOfSchemas.append(pSchema);
	
	if(createTableWizard(pDatabase, listOfSchemas))
		refresh();
}

// Run Drop Table Wizard 
void KPoGreView::dropTable()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropTable: no item selected" << endl;
		return;
	}
	
	KPGTablesFolder *pTablesFolder = static_cast <KPGTablesFolder *> (pSelectedItem->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pTablesFolder->parent());
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	dropObjectWizard(pSelectedItem, KPGTreeItem::nodeTable, "TABLE", pDatabase->connection(), pSchema->text(0));
}

// Run ALTER Table RENAME Wizard 
void KPoGreView::renameTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::renameTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  // schema qualified name
  QString strName(pSchema->text(0));
  strName.append(".");
  strName.append(pTable->text(0));
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", strName, "TABLE", i18n("table"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;    
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderTables->refresh(pqxxXaction);
  setNormalCursor();
}


// Run ANALYSE Table Wizard
void KPoGreView::analyseTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::analyseTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::analyseTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGAnalyseTableWizard wzd(this, "KPGAnalyseTableWizard", pSchema->text(0),  pTable);
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run VACUUM Table Wizard
void KPoGreView::vacuumTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::vacuumTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::vacuumTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGVacuumTableWizard wzd(this, "KPGVacuumTableWizard", pSchema->text(0),  pTable);
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run REINDEX Table Wizard
void KPoGreView::reindexTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::reindexTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::reindexTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("REINDEX TABLE ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(";");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run ALTER Table CLUSTER ON Wizard
void KPoGreView::setClusterOnTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setClusterOnTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::setClusterOnTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(pTable->getTableIndexesFolder()->childCount() == 0)
  {
    KMessageBox::sorry(this, i18n("Table has no index"));
    return;
  }
  
  KPGSetClusterTableWizard wzd(this, "KPGSetClusterTableWizard", pSchema->text(0),  pTable);
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run ALTER Table SET WITHOUT CLUSTER Wizard
void KPoGreView::setWithoutClusterTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setWithoutClusterTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::setWithoutClusterTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER TABLE ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(" SET WITHOUT CLUSTER;");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run CLUSTER Table Wizard
void KPoGreView::clusterTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::clusterTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::clusterTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("CLUSTER ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(";");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run COPY Table FROM Wizard
void KPoGreView::copyFromTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::copyFromTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::copyFromTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGCopyFromTableWizard wzd(this, "KPGCopyFromTableWizard", pSchema->text(0),  pTable);
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run COPY Table TO Wizard
void KPoGreView::copyToTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::copyToTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::copyToTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGCopyToTableWizard wzd(this, "KPGCopyToTableWizard", pSchema->text(0),  pTable);
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run ALTER Table OWNER TO new_owner Wizard
void KPoGreView::setOwnerTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::setOwnerTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
  
  QString strNamespaceTableName(pSchema->text(0) + "." + pTable->text(0));
  
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "TABLE", strNamespaceTableName, pTable->owner());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  setWaitCursor();
  pTable->refreshItem();
  pTable->displayProperties(m_pWidgetProperties);
  setNormalCursor();
}

// Run ALTER Table SET TABLESPACE tablespace_name Wizard
void KPoGreView::setTablespaceTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setTablespaceTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::setTablespaceTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
  
  QString strNamespaceTableName(pSchema->text(0) + "." + pTable->text(0));
  
  KPGSetTablespaceWizard wzd(this, "KPGSetTablespaceWizard", pServer->getTablespacesFolder(), "TABLE", strNamespaceTableName, pTable->tablespace());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
     
  setWaitCursor();
  pTable->refreshItem();
  pTable->displayProperties(m_pWidgetProperties);
  setNormalCursor();
}

// Run ALTER Table SET WITHOUT OIDS Wizard
void KPoGreView::setWithoutOIDsTable()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setWithoutOIDsTable: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTable)
  {
    kdDebug() << "KPoGreView::setWithoutOIDsTable: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem);
  KPGTablesFolder *pFolderTables = static_cast <KPGTablesFolder *> (pTable->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTables->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER TABLE ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(" SET WITHOUT OIDS;");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;  
}

// Run Create View Wizard 
void KPoGreView::createView()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createView: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderViews)
	{
		kdDebug() << "KPoGreView::createView: item types mismatch" << endl;
		return;
	}
	
	KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	QPtrList<QListViewItem> listOfSchemas;
	listOfSchemas.append(pSchema);
	
	if(createViewWizard(pDatabase, listOfSchemas))
		refresh();
}

// Run Drop View Wizard 
void KPoGreView::dropView()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropView: no item selected" << endl;
		return;
	}
		
	KPGViewsFolder *pViewsFolder = static_cast <KPGViewsFolder *> (pSelectedItem->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pViewsFolder->parent());
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	dropObjectWizard(pSelectedItem, KPGTreeItem::nodeView, "VIEW", pDatabase->connection(), pSchema->text(0));
}

// Run Create View Wizard 
void KPoGreView::modifyView()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::modifyView: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeView)
	{
		kdDebug() << "KPoGreView::modifyView: item types mismatch" << endl;
		return;
	}

	KPGView *pView = static_cast <KPGView *> (pSelectedItem);
	KPGViewsFolder *pViewsFolder = static_cast <KPGViewsFolder *> (pSelectedItem->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pViewsFolder->parent());
	KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
	
	KPGModifyViewWizard wzd(this, "KPGModifyViewWizard", pDatabase, pView);	
	wzd.setConnection(pDatabase->connection());
				
	if(wzd.exec() != QDialog::Accepted)
     return;
  		
	setWaitCursor();
	pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
	pViewsFolder->refresh(pqxxXaction);
	setNormalCursor();
}

// Run Create Tablespace Wizard 
void KPoGreView::createTablespace()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createTablespace: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTablespaces)
  {
    kdDebug() << "KPoGreView::createTablespace: item types mismatch" << endl;
    return;
  }
  
  KPGServer *pServer = static_cast <KPGServer *> (pSelectedItem->parent());
  
  createTablespaceWizard(pServer);
  
  refresh();
  pSelectedItem->displayProperties(m_pWidgetProperties);
}
  
// Run Drop Tablespace Wizard 
void KPoGreView::dropTablespace()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropTablespace: no item selected" << endl;
    return;
  }
    
  KPGTablespacesFolder *pTablespacesFolder = static_cast <KPGTablespacesFolder *> (pSelectedItem->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pTablespacesFolder->parent());
  
  dropObjectWizard(pSelectedItem, KPGTreeItem::nodeTablespace, "TABLESPACE", pServer->connection(), "", false);
}
    
// ALTER TABLESPACE name RENAME TO newname Wizard 
void KPoGreView::renameTablespace()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameTablespace: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTablespace)
  {
    kdDebug() << "KPoGreView::renameTablespace: item types mismatch" << endl;
    return;
  }
  
  KPGTablespace *pTablespace = static_cast <KPGTablespace *> (pSelectedItem);
  KPGTablespacesFolder *pTablespacesFolder = static_cast <KPGTablespacesFolder *> (pSelectedItem->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pTablespacesFolder->parent());
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", pTablespace->text(0), "TABLESPACE", i18n("tablespace"));    
  wzd.setConnection(pServer->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
  pTablespacesFolder->refresh(pqxxXaction);
  setNormalCursor();
  
  pTablespace = static_cast <KPGTablespace *> (pTablespacesFolder->getChildByName(wzd.newObjectName()));
  if(pTablespace)
  {
     m_pViewTree->ensureItemVisible(pTablespace);
     m_pViewTree->setSelected(pTablespace, true);
  }
}

// Run ALTER TABLESPACE name OWNER TO newowner Wizard 
void KPoGreView::setOwnerTablespace()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerTablespace: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTablespace)
  {
    kdDebug() << "KPoGreView::setOwnerTablespace: item types mismatch" << endl;
    return;
  }
  
  KPGTablespace *pTablespace = static_cast <KPGTablespace *> (pSelectedItem);
  KPGTablespacesFolder *pTablespacesFolder = static_cast <KPGTablespacesFolder *> (pSelectedItem->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pTablespacesFolder->parent());

  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "TABLESPACE", pTablespace->text(0), pTablespace->owner());
  wzd.setConnection(pServer->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
     
  // save tablespace name for look-up after refresh tablespaces folder 
  QString strTablespaceName(pTablespace->text(0));  
             
  setWaitCursor();
  pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
  pTablespacesFolder->refresh(pqxxXaction);
  setNormalCursor();
  
  pTablespace = static_cast <KPGTablespace *> (pTablespacesFolder->getChildByName(strTablespaceName));
  if(pTablespace)
  {
     m_pViewTree->ensureItemVisible(pTablespace);
     m_pViewTree->setSelected(pTablespace, true);
  }
}

// Run Create User Wizard 
void KPoGreView::createUser()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createUser: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderUsers)
	{
		kdDebug() << "KPoGreView::createUser: item types mismatch" << endl;
		return;
	}
	
	KPGServer *pServer = static_cast <KPGServer *> (pSelectedItem->parent());
	
	createUserWizard(pServer);
	
	refresh();
	pSelectedItem->displayProperties(m_pWidgetProperties);
}
	
// Run Drop User Wizard 
void KPoGreView::dropUser()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropUser: no item selected" << endl;
		return;
	}
		
	KPGUsersFolder *pUsersFolder = static_cast <KPGUsersFolder *> (pSelectedItem->parent());
	KPGServer *pServer = static_cast <KPGServer *> (pUsersFolder->parent());
	
	dropObjectWizard(pSelectedItem, KPGTreeItem::nodeUser, "USER", pServer->connection(), "");
}
		
// Run Alter User Wizard 
void KPoGreView::modifyUser()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::modifyUser: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeUser)
	{
		kdDebug() << "KPoGreView::modifyUser: item types mismatch" << endl;
		return;
	}
	
	KPGUser *pUser = static_cast <KPGUser *> (pSelectedItem);
	KPGUsersFolder *pUsersFolder = static_cast <KPGUsersFolder *> (pSelectedItem->parent());
	KPGServer *pServer = static_cast <KPGServer *> (pUsersFolder->parent());
	
	KPGModifyUserWizard wzd(this, "KPGModifyUserWizard", pUser);
  		
	wzd.setConnection(pServer->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
  		
	setWaitCursor();
	pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
	pUsersFolder->refresh(pqxxXaction);
	setNormalCursor();
}
	
// Run Create Group Wizard 
void KPoGreView::createGroup()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::createGroup: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderGroups)
	{
		kdDebug() << "KPoGreView::createGroup: item types mismatch" << endl;
		return;
	}
	
	KPGServer *pServer = static_cast <KPGServer *> (pSelectedItem->parent());
	
	createGroupWizard(pServer);
	
	refresh();
	pSelectedItem->displayProperties(m_pWidgetProperties);
}
	
// Run Drop Group Wizard 
void KPoGreView::dropGroup()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::dropGroup: no item selected" << endl;
		return;
	}
		
	KPGGroupsFolder *pGroupsFolder = static_cast <KPGGroupsFolder *> (pSelectedItem->parent());
	KPGServer *pServer = static_cast <KPGServer *> (pGroupsFolder->parent());
	
	dropObjectWizard(pSelectedItem, KPGTreeItem::nodeGroup, "GROUP", pServer->connection(), "");
}
		
// Run Alter Group Wizard 
void KPoGreView::modifyGroup()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(! pSelectedItem)
	{
		kdDebug() << "KPoGreView::modifyGroup: no item selected" << endl;
		return;
	}
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeGroup)
	{
		kdDebug() << "KPoGreView::modifyGroup: item types mismatch" << endl;
		return;
	}
	
	KPGGroup *pGroup = static_cast <KPGGroup *> (pSelectedItem);
	KPGGroupsFolder *pGroupsFolder = static_cast <KPGGroupsFolder *> (pSelectedItem->parent());
	KPGServer *pServer = static_cast <KPGServer *> (pGroupsFolder->parent());
	
	KPGModifyGroupWizard wzd(this, "KPGModifyGroupWizard", pGroup, pServer->getUsersFolder());
  		
	wzd.setConnection(pServer->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
  		
	setWaitCursor();
	pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
	pGroupsFolder->refresh(pqxxXaction);
	setNormalCursor();
}

// Run Create Language Wizard 
void KPoGreView::createLanguage()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createLanguage: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderLanguages)
  {
    kdDebug() << "KPoGreView::createLanguage: item types mismatch" << endl;
    return;
  }
  
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSelectedItem->parent());
    
  if(createLanguageWizard(pDatabase))
    refresh();
}
  
// Run Drop Language Wizard 
void KPoGreView::dropLanguage()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropLanguage: no item selected" << endl;
    return;
  }
    
  KPGLanguagesFolder *pLanguagesFolder = static_cast <KPGLanguagesFolder *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pLanguagesFolder->parent());
  
  dropObjectWizard(pSelectedItem, KPGTreeItem::nodeLanguage, "LANGUAGE", pDatabase->connection(), "");
}
  
// Run Alter Language Wizard 
void KPoGreView::modifyLanguage()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::modifyLanguage: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeLanguage)
  {
    kdDebug() << "KPoGreView::modifyLanguage: item types mismatch" << endl;
    return;
  }

  KPGLanguage *pLanguage = static_cast <KPGLanguage *> (pSelectedItem);
  KPGLanguagesFolder *pLanguagesFolder = static_cast <KPGLanguagesFolder *> (pLanguage->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pLanguagesFolder->parent());
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", pLanguage->text(0), "LANGUAGE", i18n("language"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pLanguagesFolder->refresh(pqxxXaction);
  setNormalCursor();
}
    
// Run Create Domain Wizard 
void KPoGreView::createDomain()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createDomain: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderDomains)
  {
    kdDebug() << "KPoGreView::createDomain: item types mismatch" << endl;
    return;
  }
  
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QPtrList<QListViewItem> listOfSchemas;
  listOfSchemas.append(pSchema);
  
  if(createDomainWizard(pDatabase, listOfSchemas))
    refresh();
}

// Run DROP DOMAIN Wizard 
void KPoGreView::dropDomain()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropDomain: no item selected" << endl;
    return;
  }
    
  KPGDomainsFolder *pDomainsFolder = static_cast <KPGDomainsFolder *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pDomainsFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  dropObjectWizard(pSelectedItem, KPGTreeItem::nodeDomain, "DOMAIN", pDatabase->connection(), pSchema->text(0));
}

// Run ALTER DOMAIN SET | DROP NOT NULL Wizard 
void KPoGreView::setDomainNull()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setDomainNull: no item selected" << endl;
    return;
  }

  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDomain)
  {
    kdDebug() << "KPoGreView::setDomainNull: item types mismatch" << endl;
    return;
  }

  KPGDomain *pDomain = static_cast <KPGDomain *> (pSelectedItem);
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER DOMAIN ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pDomain->text(0));
    
  if(!pDomain->isNotNull())
    strSQL.append(" SET NOT NULL;");
  else
    strSQL.append(" DROP NOT NULL;");
    
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, true);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  // save domain name for look-up after refresh columns folder 
  QString strDomainName(pDomain->text(0));   
  
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderDomains->refresh(pqxxXaction);
  setNormalCursor();
  
  pDomain = static_cast <KPGDomain *> (pFolderDomains->getChildByName(strDomainName));
  if(pDomain)
  {
     m_pViewTree->ensureItemVisible(pDomain);
     m_pViewTree->setSelected(pDomain, true);
  }
}

// Run ALTER DOMAIN SET DEFAULT expression Wizard 
void KPoGreView::setDomainDefault()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setDomainDefault: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDomain)
  {
    kdDebug() << "KPoGreView::setDomainNull: item types mismatch" << endl;
    return;
  }

  KPGDomain *pDomain = static_cast <KPGDomain *> (pSelectedItem);
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGSetDomainDefaultWizard wzd(this, "KPGSetDomainDefaultWizard", pSchema->text(0), pDomain->text(0));
  wzd.setConnection(pDatabase->connection());
  wzd.setDefaultExpression(pDomain->defaultValue());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
       
  // save domain name for look-up after refresh columns folder 
  QString strDomainName(pDomain->text(0));   
  
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderDomains->refresh(pqxxXaction);
  setNormalCursor();
  
  pDomain = static_cast <KPGDomain *> (pFolderDomains->getChildByName(strDomainName));
  if(pDomain)
  {
     m_pViewTree->ensureItemVisible(pDomain);
     m_pViewTree->setSelected(pDomain, true);
  }
}

// Run ALTER DOMAIN DROP DEFAULT Wizard 
void KPoGreView::dropDomainDefault()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropDomainDefault: no item selected" << endl;
    return;
  }
    
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDomain)
  {
    kdDebug() << "KPoGreView::setDomainNull: item types mismatch" << endl;
    return;
  }

  KPGDomain *pDomain = static_cast <KPGDomain *> (pSelectedItem);
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());  
  
  QString strSQL("ALTER DOMAIN ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pDomain->text(0));
  strSQL.append(" DROP DEFAULT;");
    
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, true);
      
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
  
  // save domain name for look-up after refresh columns folder 
  QString strDomainName(pDomain->text(0));   
  
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderDomains->refresh(pqxxXaction);
  setNormalCursor();
  
  pDomain = static_cast <KPGDomain *> (pFolderDomains->getChildByName(strDomainName));
  if(pDomain)
  {
     m_pViewTree->ensureItemVisible(pDomain);
     m_pViewTree->setSelected(pDomain, true);
  }
}

// Run ALTER DOMAIN name OWNER TO new_owner  Wizard 
void KPoGreView::setOwnerDomain()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropDomainDefault: no item selected" << endl;
    return;
  }
    
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDomain)
  {
    kdDebug() << "KPoGreView::setDomainNull: item types mismatch" << endl;
    return;
  }

  KPGDomain *pDomain = static_cast <KPGDomain *> (pSelectedItem);
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());  
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent());
  
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "DOMAIN", pDomain->text(0), pDomain->owner());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
     
  // save domain name for look-up after refresh domain folder 
  QString strDomainName(pDomain->text(0)); 
             
  setWaitCursor();
  pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
  pFolderDomains->refresh(pqxxXaction);
  setNormalCursor();
  
  pDomain = static_cast <KPGDomain *> (pFolderDomains->getChildByName(strDomainName));
  if(pDomain)
  {
     m_pViewTree->ensureItemVisible(pDomain);
     m_pViewTree->setSelected(pDomain, true);
  }
}

// Run ALTER DOMAIN name ADD domain_constraint Wizard 
void KPoGreView::createDomainConstraint()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createDomainConstraint: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderDomainConstraints)
  {
    kdDebug() << "KPoGreView::createDomainConstraint: item types mismatch" << endl;
    return;
  }
  
  KPGDomain *pDomain = static_cast <KPGDomain *> (pSelectedItem->parent());
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGCreateDomainConstraintWizard wzd(this, "KPGCreateDomainConstraintWizard", pSchema->text(0), pDomain->text(0));
  wzd.setConnection(pDatabase->connection());
  
  if(wzd.exec() != QDialog::Accepted)
     return; 

  refresh();   
}

// Run ALTER DOMAIN name DROP CONSTRAINT constraint_name Wizard 
void KPoGreView::dropDomainConstraint()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropDomainConstraint: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeDomainConstr)
  {
    kdDebug() << "KPoGreView::dropDomainConstraint: item types mismatch" << endl;
    return;
  }
  
  KPGDomainConstraint *pDomainConstraint = static_cast <KPGDomainConstraint *> (pSelectedItem);
  KPGDomainConstraintsFolder *pDomainConstraintsFolder = static_cast <KPGDomainConstraintsFolder *> (pDomainConstraint->parent());
  KPGDomain *pDomain = static_cast <KPGDomain *> (pDomainConstraintsFolder->parent());
  KPGDomainsFolder *pFolderDomains = static_cast <KPGDomainsFolder *> (pDomain->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderDomains->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER DOMAIN ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pDomain->text(0));
  strSQL.append(" DROP CONSTRAINT ");
  strSQL.append(pDomainConstraint->text(0));
  strSQL.append(";");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, true);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
   return;
  
  // Refresh parent item
  setWaitCursor();
  pDomainConstraintsFolder->refresh();
  setNormalCursor();
}

// Run Create Function Wizard 
void KPoGreView::createFunction()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createFunction: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderFunctions)
  {
    kdDebug() << "KPoGreView::createFunction: item types mismatch" << endl;
    return;
  }
  
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QPtrList<QListViewItem> listOfSchemas;
  listOfSchemas.append(pSchema);
  
  if(createFunctionWizard(pDatabase, listOfSchemas))
    refresh();
}
  
// Run Drop Function Wizard 
void KPoGreView::dropFunction()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropFunction: no item selected" << endl;
    return;
  }
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFunction)
  {
    kdDebug() << "KPoGreView::dropFunction: item types mismatch" << endl;
    return;
  }
    
  KPGFunctionsFolder *pFunctionsFolder = static_cast <KPGFunctionsFolder *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFunctionsFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGDropObjectWizard wzd(
		this, 
		"KPGDropObjectWizard", 
		"FUNCTION",
		pSchema->text(0),
		pSelectedItem->text(0) + " (" + (static_cast <KPGFunction *> (pSelectedItem))->argTypes() + ")"
		);
  
	wzd.setConnection(pDatabase->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
	
	// Refresh parent item
	setWaitCursor();
	pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
	pFunctionsFolder->refresh(pqxxXaction);
	setNormalCursor();	 	 
}
    
// Run Alter Function Wizard 
void KPoGreView::renameFunction()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameFunction: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFunction)
  {
    kdDebug() << "KPoGreView::renameFunction: item types mismatch" << endl;
    return;
  }

  KPGFunction *pFunction = static_cast <KPGFunction *> (pSelectedItem);
  KPGFunctionsFolder *pFolderFunctions = static_cast <KPGFunctionsFolder *> (pFunction->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderFunctions->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  // append arguments to function name
  QString strName(pSchema->text(0));
  strName.append(".");
  strName.append(pFunction->text(0));
  strName.append(" (");
  strName.append(pFunction->argTypes()); 
  strName.append(")"); 
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", strName, "FUNCTION", i18n("function"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderFunctions->refresh(pqxxXaction);
  setNormalCursor();
}

// Run Alter Function Wizard 
void KPoGreView::modifyFunction()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::modifyFunction: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFunction)
  {
    kdDebug() << "KPoGreView::modifyFunction: item types mismatch" << endl;
    return;
  }

  KPGFunction *pFunction = static_cast <KPGFunction *> (pSelectedItem);
  KPGFunctionsFolder *pFunctionsFolder = static_cast <KPGFunctionsFolder *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFunctionsFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGModifyFunctionWizard wzd(this, "KPGModifyFunctionWizard", pFunction);   
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFunctionsFolder->refresh(pqxxXaction);
  setNormalCursor();
}
    
// Run Create Sequence Wizard 
void KPoGreView::createSequence()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createSequence: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderSequences)
  {
    kdDebug() << "KPoGreView::createSequence: item types mismatch" << endl;
    return;
  }
  
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QPtrList<QListViewItem> listOfSchemas;
  listOfSchemas.append(pSchema);
  
  if(createSequenceWizard(pDatabase, listOfSchemas))
    refresh();
}
  
// Run Drop Sequence Wizard 
void KPoGreView::dropSequence()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropSequence: no item selected" << endl;
    return;
  }
    
  KPGSequencesFolder *pSequencesFolder = static_cast <KPGSequencesFolder *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSequencesFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  dropObjectWizard(pSelectedItem, KPGTreeItem::nodeSequence, "SEQUENCE", pDatabase->connection(), pSchema->text(0));
}

// Run ALTER Sequence Wizard 
void KPoGreView::modifySequence()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::modifySequence: no item selected" << endl;
    return;
  }
  
  KPGSequence *pSequence = static_cast <KPGSequence *> (pSelectedItem);
  KPGSequencesFolder *pSequencesFolder = static_cast <KPGSequencesFolder *> (pSequence->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSequencesFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
 
  KPGModifySequenceWizard wzd(this, "KPGModifySequenceWizard", pSchema->text(0), pSequence);
  wzd.setConnection(pDatabase->connection());
        
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  // save sequence name for look-up after refresh columns folder 
  QString strSequenceName(pSequence->text(0));   
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pSequencesFolder->refresh(pqxxXaction);
  setNormalCursor();
  
  pSequence = static_cast <KPGSequence *> (pSequencesFolder->getChildByName(strSequenceName));
  if(pSequence)
  {
     m_pViewTree->ensureItemVisible(pSequence);
     m_pViewTree->setSelected(pSequence, true);
  }
}

// Run ALTER table ADD Column Wizard
void KPoGreView::createColumn()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createColumn: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTableColumns)
  {
    kdDebug() << "KPoGreView::createColumn: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(createColumnWizard(pDatabase, pSchema, pTable))
  {
    refresh();
    pSelectedItem->displayProperties(m_pWidgetProperties);
  }
}
    
// Run ALTER table DROP Column Wizard
void KPoGreView::dropColumn()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropColumn: no item selected" << endl;
    return;
  }
    
  KPGTableColumnsFolder *pColumnsFolder = static_cast <KPGTableColumnsFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pColumnsFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  dropTableObjectWizard(pSelectedItem, "COLUMN", pDatabase->connection(), pSchema->text(0), pTable->text(0)); 
}
       
// Run ALTER table Rename Column Wizard
void KPoGreView::renameColumn()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameColumn: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::renameColumn: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strNamespaceTableName(pSchema->text(0) + "." + pTable->text(0));
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", strNamespaceTableName, pColumn->text(0), "COLUMN", i18n("column"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
      
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(wzd.newObjectName()));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}
       
// Run ALTER table SET/DROP Column NULL Wizard
void KPoGreView::setColumnNull()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setColumnNull: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::setColumnNull: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER TABLE ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(" ALTER COLUMN ");
  strSQL.append(pColumn->text(0));
  
  if(!pColumn->isNotNull())
    strSQL.append(" SET NOT NULL;");
  else
    strSQL.append(" DROP NOT NULL;");
    
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, true);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0));   
  
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}
       
// Run ALTER table ALTER Column SET DEFAULT Wizard
void KPoGreView::setColumnDefault()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setColumnDefault: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::setColumnDefault: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());

  KPGModifyTableColumnWizard wzd(this, "KPGModifyTableColumnWizard", pSchema, pTable, pColumn, KPGModifyTableColumnWizard::modeDefault);
  wzd.setConnection(pDatabase->connection());
  wzd.setDefaultExpression(pColumn->defaultValue());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
       
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0));  
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}

// Run ALTER table ALTER Column DROP DEFAULT Wizard
void KPoGreView::dropColumnDefault()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropColumnDefault: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::dropColumnDefault: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strSQL("ALTER TABLE ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pTable->text(0));
  strSQL.append(" ALTER COLUMN ");
  strSQL.append(pColumn->text(0));
  strSQL.append(" DROP DEFAULT;");
    
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, true);
      
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
  
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0)); 
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
      
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}
       
// Run ALTER table ALTER Column TYPE Wizard
void KPoGreView::changeColumnType()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::changeColumnType: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::changeColumnType: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());

  KPGModifyTableColumnWizard wzd(this, "KPGModifyTableColumnWizard", pSchema, pTable, pColumn, KPGModifyTableColumnWizard::modeType);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
       
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0));  
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}
       
// Run ALTER table ALTER Column SET STORAGE { PLAIN | EXTERNAL | EXTENDED | MAIN } Wizard
void KPoGreView::setColumnStorage()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setColumnStorage: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::setColumnStorage: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());

  KPGModifyTableColumnWizard wzd(this, "KPGModifyTableColumnWizard", pSchema, pTable, pColumn, KPGModifyTableColumnWizard::modeStorage);
  wzd.setConnection(pDatabase->connection());
  wzd.setStorage(pColumn->storage());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
       
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0));  
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}
       
// Run ALTER table ALTER Column SET STATISTICS Wizard
void KPoGreView::setColumnStatistisc()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setColumnStatistisc: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTableColumn)
  {
    kdDebug() << "KPoGreView::setColumnStatistisc: item types mismatch" << endl;
    return;
  }

  KPGTableColumn *pColumn = static_cast <KPGTableColumn *> (pSelectedItem);
  KPGTableColumnsFolder *pFolderColumns = static_cast <KPGTableColumnsFolder *> (pColumn->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pFolderColumns->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());

  KPGModifyTableColumnWizard wzd(this, "KPGModifyTableColumnWizard", pSchema, pTable, pColumn, KPGModifyTableColumnWizard::modeStats);
  wzd.setConnection(pDatabase->connection());
  wzd.setStatTarget(pColumn->statTarget());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
       
  // save column name for look-up after refresh columns folder 
  QString strColumnName(pColumn->text(0));  
     
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pFolderColumns->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pColumn = static_cast <KPGTableColumn *> (pFolderColumns->getChildByName(strColumnName));
  if(pColumn)
  {
     m_pViewTree->ensureItemVisible(pColumn);
     m_pViewTree->setSelected(pColumn, true);
  }
}

// Run Create Constraint Wizard 
void KPoGreView::createConstraint()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createConstraint: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTableConstraints)
  {
    kdDebug() << "KPoGreView::createConstraint: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(createConstraintWizard(pDatabase, pSchema, pTable))
  {
    refresh();
    pSelectedItem->displayProperties(m_pWidgetProperties);
  }
}

// Run Drop Constraint Wizard 
void KPoGreView::dropConstraint()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropConstraint: no item selected" << endl;
    return;
  }
    
  KPGTableConstraintsFolder *pConstraintsFolder = static_cast <KPGTableConstraintsFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pConstraintsFolder->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  dropTableObjectWizard(pSelectedItem, "CONSTRAINT", pDatabase->connection(), pSchema->text(0), pTable->text(0));  
}

// Run Create Index Wizard 
void KPoGreView::createIndex()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createIndex: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTableIndexes)
  {
    kdDebug() << "KPoGreView::createIndex: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(createIndexWizard(pDatabase, pSchema, pTable))
  {
    refresh();
    pSelectedItem->displayProperties(m_pWidgetProperties);
  }
}

// Run Drop Index Wizard 
void KPoGreView::dropIndex()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropIndex: no item selected" << endl;
    return;
  }
	
	if(((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeIndex) &&
     ((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodePrimaryKey)
    )
  {
    kdDebug() << "KPoGreView::renameIndex: item types mismatch" << endl;
    return;
  }
    
  KPGTableIndexesFolder *pIndexesFolder = static_cast <KPGTableIndexesFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pIndexesFolder->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  	  
  KPGDropObjectWizard wzd(
		this, 
		"KPGDropObjectWizard", 
		"INDEX",
		pSchema->text(0),
		pSelectedItem->text(0)
		);
  
	wzd.setConnection(pDatabase->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
	
	// Refresh parent item
	setWaitCursor();
	pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
	pIndexesFolder->refresh(pqxxXaction, pTable->oid());
	setNormalCursor();	 
}

// Run ALTER Index RENAME Wizard 
void KPoGreView::renameIndex()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameIndex: no item selected" << endl;
    return;
  }
  
  if(((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeIndex) &&
     ((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodePrimaryKey)
    )
  {
    kdDebug() << "KPoGreView::renameIndex: item types mismatch" << endl;
    return;
  }
  
  KPGTableIndexesFolder *pIndexesFolder = static_cast <KPGTableIndexesFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pIndexesFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
  // schema qualified name
  QString strName(pSchema->text(0));
  strName.append(".");
  strName.append(pSelectedItem->text(0));
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", strName, "INDEX", i18n("index"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;    
  
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pIndexesFolder->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pSelectedItem = pIndexesFolder->getChildByName(wzd.newObjectName());
  if(pSelectedItem)
  {
     m_pViewTree->ensureItemVisible(pSelectedItem);
     m_pViewTree->setSelected(pSelectedItem, true);
  }   
}

// Run REINDX INDEX Wizard 
void KPoGreView::reindexIndex()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::reindexIndex: no item selected" << endl;
    return;
  }
  
  if(((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeIndex) &&
     ((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodePrimaryKey)
    )
  {
    kdDebug() << "KPoGreView::reindexIndex: item types mismatch" << endl;
    return;
  }
  
  KPGTableIndexesFolder *pIndexesFolder = static_cast <KPGTableIndexesFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pIndexesFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
    
  QString strSQL("REINDEX INDEX ");
  strSQL.append(pSchema->text(0));
  strSQL.append(".");
  strSQL.append(pSelectedItem->text(0));
  strSQL.append(";");
  
  KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, false);
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
}

// Run ALTER Index OWNER TO new_owner Wizard
void KPoGreView::setOwnerIndex()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerIndex: no item selected" << endl;
    return;
  }
  
  if(((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeIndex) &&
     ((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodePrimaryKey)
    )
  {
    kdDebug() << "KPoGreView::setOwnerIndex: item types mismatch" << endl;
    return;
  }
  
  KPGTableIndex *pIndex = static_cast <KPGTableIndex *> (pSelectedItem);
  KPGTableIndexesFolder *pIndexesFolder = static_cast <KPGTableIndexesFolder *> (pIndex->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pIndexesFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
    
  QString strNamespaceIndexName(pSchema->text(0) + "." + pSelectedItem->text(0));
  
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "INDEX", strNamespaceIndexName, "");
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run ALTER Index SET TABLESPACE indexspace_name Wizard 
void KPoGreView::setTablespaceIndex()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setTablespaceIndex: no item selected" << endl;
    return;
  }
  
  if(((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeIndex) &&
     ((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodePrimaryKey)
    )
  {
    kdDebug() << "KPoGreView::setTablespaceIndex: item types mismatch" << endl;
    return;
  }
  
  KPGTableIndex *pIndex = static_cast <KPGTableIndex *> (pSelectedItem);
  KPGTableIndexesFolder *pIndexesFolder = static_cast <KPGTableIndexesFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pIndexesFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
    
  QString strNamespaceIndexName(pSchema->text(0) + "." + pSelectedItem->text(0));
  
  KPGSetTablespaceWizard wzd(this, "KPGSetTablespaceWizard", pServer->getTablespacesFolder(), "INDEX", strNamespaceIndexName, pIndex->tablespace());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return; 
}

// Run Create Rule Wizard 
void KPoGreView::createRule()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createRule: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderRules)
  {
    kdDebug() << "KPoGreView::createRule: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(createRuleWizard(pDatabase, pSchema, pTable))
  {
    refresh();
    pSelectedItem->displayProperties(m_pWidgetProperties);
  }
}
  
// Run Drop Rule Wizard 
void  KPoGreView::dropRule()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropRule: no item selected" << endl;
    return;
  }
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeRule)
  {
    kdDebug() << "KPoGreView::dropRule: item types mismatch" << endl;
    return;
  }
    
  KPGRulesFolder *pRulesFolder = static_cast <KPGRulesFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pRulesFolder->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGDropObjectWizard wzd(
		this, 
		"KPGDropObjectWizard", 
		"RULE",
		pSchema->text(0),
		pSelectedItem->text(0),
		pTable->text(0)
		);
  
	wzd.setConnection(pDatabase->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
	
	// Refresh parent item
	setWaitCursor();
	pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
	pRulesFolder->refresh(pqxxXaction, pTable->oid());
	setNormalCursor();	 
}
    
// Run Create Trigger Wizard 
void  KPoGreView::createTrigger()
{
    KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createTrigger: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTriggers)
  {
    kdDebug() << "KPoGreView::createTrigger: item types mismatch" << endl;
    return;
  }
  
  KPGTable *pTable = static_cast <KPGTable *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  if(createTriggerWizard(pDatabase, pSchema, pTable))
  {
    refresh();
    pSelectedItem->displayProperties(m_pWidgetProperties);
  }
}
  
// Run Drop Trigger Wizard 
void  KPoGreView::dropTrigger()
{
	KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropTrigger: no item selected" << endl;
    return;
  }
	
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTrigger)
  {
    kdDebug() << "KPoGreView::dropTrigger: item types mismatch" << endl;
    return;
  }
    
  KPGTriggersFolder *pTriggersFolder = static_cast <KPGTriggersFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pTriggersFolder->parent());
	KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGDropObjectWizard wzd(
		this, 
		"KPGDropObjectWizard", 
		"TRIGGER",
		pSchema->text(0),
		pSelectedItem->text(0),
		pTable->text(0)
		);
  
	wzd.setConnection(pDatabase->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return;
	
	// Refresh parent item
	setWaitCursor();
	pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
	pTriggersFolder->refresh(pqxxXaction, pTable->oid());
	setNormalCursor();	 
}

// Run ALTER Trigger RENAME Wizard 
void  KPoGreView::renameTrigger()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::renameTrigger: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeTrigger)
  {
    kdDebug() << "KPoGreView::renameTrigger: item types mismatch" << endl;
    return;
  }
  
  KPGTriggersFolder *pTriggersFolder = static_cast <KPGTriggersFolder *> (pSelectedItem->parent());
  KPGTable *pTable = static_cast <KPGTable *> (pTriggersFolder->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTable->parent()->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QString strNamespaceTableName(pSchema->text(0) + "." + pTable->text(0));
  
  KPGRenameObjectWizard wzd(this, "KPGRenameObjectWizard", strNamespaceTableName, pSelectedItem->text(0),  "TRIGGER", i18n("trigger"));
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
 
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pTriggersFolder->refresh(pqxxXaction, pTable->oid());
  setNormalCursor();
  
  pSelectedItem = pTriggersFolder->getChildByName(wzd.newObjectName());
  if(pSelectedItem)
  {
     m_pViewTree->ensureItemVisible(pSelectedItem);
     m_pViewTree->setSelected(pSelectedItem, true);
  }    
}

void KPoGreView::createBaseType()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createBaseType: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTypes)
  {
    kdDebug() << "KPoGreView::createBaseType: item types mismatch" << endl;
    return;
  }
  
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QPtrList<QListViewItem> listOfSchemas;
  listOfSchemas.append(pSchema);
  
  if(createBaseTypeWizard(pDatabase, listOfSchemas))
    refresh();
}

void KPoGreView::createCompositeType()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::createCompositeType: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeFolderTypes)
  {
    kdDebug() << "KPoGreView::createCompositeType: item types mismatch" << endl;
    return;
  }
  
  KPGSchema *pSchema = static_cast <KPGSchema *> (pSelectedItem->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  QPtrList<QListViewItem> listOfSchemas;
  listOfSchemas.append(pSchema);
  
  if(createCompositeTypeWizard(pDatabase, listOfSchemas))
    refresh();
}

void KPoGreView::dropType()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::dropTable: no item selected" << endl;
    return;
  }
  
  KPGTypesFolder *pTypesFolder = static_cast <KPGTypesFolder *> (pSelectedItem->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pTypesFolder->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  
  KPGDropObjectWizard wzd(
    this, 
    "KPGDropObjectWizard", 
    "TYPE",
    pSchema->text(0),
    pSelectedItem->text(0)
    );
  
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return;
  
  // Refresh parent item
  setWaitCursor();
  pqxx::work pqxxXaction(* pDatabase->connection(), "refresh folder");
  pTypesFolder->refresh(pqxxXaction);
  setNormalCursor();
}

void KPoGreView::setOwnerType()
{
  KPGTreeItem * pSelectedItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
  if(! pSelectedItem)
  {
    kdDebug() << "KPoGreView::setOwnerType: no item selected" << endl;
    return;
  }
  
  if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != KPGTreeItem::nodeType)
  {
    kdDebug() << "KPoGreView::setOwnerType: item types mismatch" << endl;
    return;
  }
  
  KPGType *pType = static_cast <KPGType *> (pSelectedItem);
  KPGTypesFolder *pFolderTypes = static_cast <KPGTypesFolder *> (pType->parent());
  KPGSchema *pSchema = static_cast <KPGSchema *> (pFolderTypes->parent());
  KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSchema->parent());
  KPGServer *pServer = static_cast <KPGServer *> (pDatabase->parent()); 
  
  QString strNamespaceTypeName(pSchema->text(0) + "." + pType->text(0));
  
  KPGSetOwnerWizard wzd(this, "KPGSetOwnerWizard", pServer->getUsersFolder(), "TYPE", strNamespaceTypeName, pType->owner());
  wzd.setConnection(pDatabase->connection());
      
  if(wzd.exec() != QDialog::Accepted)
     return;
     
  // save domain name for look-up after refresh types folder 
  QString strTypName(pType->text(0)); 
             
  setWaitCursor();
  pqxx::work pqxxXaction(* pServer->connection(), "refresh folder");
  pFolderTypes->refresh(pqxxXaction);
  setNormalCursor();
  
  pType = static_cast <KPGType *> (pFolderTypes->getChildByName(strTypName));
  if(pType)
  {
     m_pViewTree->ensureItemVisible(pType);
     m_pViewTree->setSelected(pType, true);
  }
}
  

/////////////////////////////////////////////////////////////////////
//                           OTHER SLOTS
/////////////////////////////////////////////////////////////////////


void KPoGreView::slotTabWidgetCurrentChanged(QWidget * pNewCurrentPage)
{
	if(pNewCurrentPage != m_pWidgetProperties)
	{
		// user selected SQL query/result window - update their connections list
		KPGSqlQueryResultWindow* pQueryResultWindow = static_cast <KPGSqlQueryResultWindow *> (pNewCurrentPage);
		
		// store selected server and database
		QString strServer(pQueryResultWindow->m_pComboBoxServer->currentText());
		QString strDatabase(pQueryResultWindow->m_pComboBoxDatabase->currentText());
		
		pQueryResultWindow->m_pComboBoxServer->clear();
		pQueryResultWindow->m_pComboBoxDatabase->clear();
		
		QStringList strLisOfActiveDbConnections;
		bool bEnableRunQueryAction = false;
		//bool bFirstServerAdded = false;
		
		QListViewItem * pItem = m_pViewTree->firstChild();
		while(pItem)
		{
			if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
			{
				KPGServer *pServer = static_cast <KPGServer *> (pItem);
								
				//--- traverse list of connected databases
				QListViewItem * pItem2 = pServer->firstChild();
				
				if(pItem2)
					pQueryResultWindow->m_pComboBoxServer->insertItem(*pServer->pixmap(0), pServer->text(0));
					
				if(strServer == pServer->text(0)) // add databases for selected server
				{					
					while(pItem2)
					{
						if((static_cast <KPGTreeItem *> (pItem2))->type() == KPGTreeItem::nodeDatabase)
						{
							KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pItem2);
							if(pDatabase->connection())
								{ 
									pQueryResultWindow->m_pComboBoxDatabase->insertItem(*pDatabase->pixmap(0), pDatabase->text(0));
								}
						}
						pItem2 = pItem2->nextSibling();
					}	
				}
								 
			}
			pItem = pItem->nextSibling();
		}
		
		// restore selected values
		if(strServer.length() > 0)
			pQueryResultWindow->m_pComboBoxServer->setCurrentText(strServer);
		else
			slotRequestDatabasesList(pQueryResultWindow, pQueryResultWindow->m_pComboBoxServer->currentText()); 
			
		if(strDatabase.length() > 0)
			pQueryResultWindow->m_pComboBoxDatabase->setCurrentText(strDatabase);
			
		if(pQueryResultWindow->m_pComboBoxDatabase->count() > 0)
			bEnableRunQueryAction = true;

		emit sigEnableRunQueryAction(bEnableRunQueryAction);
		emit sigEnableFileActions(true, 
															pQueryResultWindow->queryTextChanged(), 
															!pQueryResultWindow->resultEmpty()
														 );
														
		emit sigEnableEditActions(pQueryResultWindow->editQuery()->isUndoAvailable(),
															pQueryResultWindow->editQuery()->isRedoAvailable(), 
															pQueryResultWindow->editQuery()->hasSelectedText(),
															true,
															true,
															pQueryResultWindow->editQuery()->length() > 0
														 );
	}
	else
		{ 
			emit sigEnableRunQueryAction(false);
			emit sigEnableFileActions(false, false, false);
			emit sigEnableEditActions(false, false, false, false, m_pViewTree->selectedItem() != 0, false);
		}
}

void KPoGreView::slotSchemaPropTabChanged(KPGSchemaPropPage *pPropertyPage, QWidget * pNewCurrentPage)
{
	 KPGTreeItem * pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());
	if(pItem )
  {
    if(pItem->type() != KPGTreeItem::nodeSchema)
      return;
			
		KPGSchema *pSchema = static_cast <KPGSchema *> (pItem);
		pSchema->displayTabPage(pPropertyPage, pNewCurrentPage);
			
	}
}

// Show popup for item in tree rightpressed
void KPoGreView::slotTreeViewRightButtonPressed(QListViewItem* pressedItem, const QPoint& point, int column)
{
		if(column >= 0)
    {
      KPGTreeItem * pItem = static_cast <KPGTreeItem *> (pressedItem);
			
      switch(pItem->type())
      {
        //******************************************************************************************
				//
				// Main objects
				//
				//******************************************************************************************
				
				case KPGTreeItem::nodeServer:
				  emit sigContextMenuRequested("popupServer", point);
					break;
				
				case KPGTreeItem::nodeDatabase:
				  emit sigContextMenuRequested("popupDatabase", point);
					break; 
				
				case KPGTreeItem::nodeSchema:
				  emit sigContextMenuRequested("popupSchema", point);
					break; 
					
				case KPGTreeItem::nodeFolderUsers:
					emit sigContextMenuRequested("popupFolderUsers", point);
					break;
				
				case KPGTreeItem::nodeFolderGroups:
					emit sigContextMenuRequested("popupFolderGroups", point);
					break;

				case KPGTreeItem::nodeFolderTablespaces:
					emit sigContextMenuRequested("popupFolderTablespaces", point);
					break;
					
				case KPGTreeItem::nodeTablespace:
				  emit sigContextMenuRequested("popupTablespace", point);
					break; 
												
				//******************************************************************************************
				//
				// Database objects folders
				//
				//******************************************************************************************
				
				case KPGTreeItem::nodeFolderTables:
					emit sigContextMenuRequested("popupFolderTables", point);
					break; 
				
				case KPGTreeItem::nodeFolderViews:
					emit sigContextMenuRequested("popupFolderViews", point);
					break; 
				
				case KPGTreeItem::nodeFolderSequences:
					emit sigContextMenuRequested("popupFolderSequences", point);
					break; 
				
				case KPGTreeItem::nodeFolderFunctions:
					emit sigContextMenuRequested("popupFolderFunctions", point);
					break;
				
				case KPGTreeItem::nodeFolderOperators:
					emit sigContextMenuRequested("popupFolderOperators", point);
					break; 
					
				case KPGTreeItem::nodeFolderOperatorClasses:
					emit sigContextMenuRequested("popupFolderOperatorClasses", point);
					break; 
				
				case KPGTreeItem::nodeFolderAggregates:
					emit sigContextMenuRequested("popupFolderAggregates", point);
					break;
					
				case KPGTreeItem::nodeFolderDomains:
					emit sigContextMenuRequested("popupFolderDomains", point);
					break;
				
				case KPGTreeItem::nodeFolderTypes:
					emit sigContextMenuRequested("popupFolderTypes", point);
					break;
				
				case KPGTreeItem::nodeFolderLanguages:
					emit sigContextMenuRequested("popupFolderLanguages", point);
					break;
				
				case KPGTreeItem::nodeFolderConversions:
					emit sigContextMenuRequested("popupFolderConversions", point);
					break;
					
				case KPGTreeItem::nodeFolderCasts:
					emit sigContextMenuRequested("popupFolderCasts", point);
					break;		
				
				//******************************************************************************************
				//
				// Database objects
				//
				//******************************************************************************************
				
				case KPGTreeItem::nodeTable:
						emit sigContextMenuRequested("popupTable", point);
					break; 
				
				case KPGTreeItem::nodeView:
						emit sigContextMenuRequested("popupView", point);
					break; 
				
				case KPGTreeItem::nodeFunction:
          emit sigContextMenuRequested("popupFunction", point);
					break; 
				
				case KPGTreeItem::nodeSequence:
          emit sigContextMenuRequested("popupSequence", point);
					break;
									 
				case KPGTreeItem::nodeOperator:
					break; 
					
				case KPGTreeItem::nodeOperatorClass:
					break; 
					
				case KPGTreeItem::nodeAggregate:
					break;
					
				case KPGTreeItem::nodeDomain:
          emit sigContextMenuRequested("popupDomain", point);
					break;
					
				case KPGTreeItem::nodeType:
          emit sigContextMenuRequested("popupType", point);
					break;
					
				case KPGTreeItem::nodeLanguage:
          emit sigContextMenuRequested("popupLanguage", point);
					break;
					
				case KPGTreeItem::nodeConversion:
					break;
					
				case KPGTreeItem::nodeCast:
					break;	 
				
				case KPGTreeItem::nodeUser:
					emit sigContextMenuRequested("popupUser", point);
					break; 
				
				case KPGTreeItem::nodeGroup:
					emit sigContextMenuRequested("popupGroup", point);
					break;	 
				
				//******************************************************************************************
				//
				// Table objects folders
				//
				//******************************************************************************************
				
				case KPGTreeItem::nodeFolderTableColumns:
					emit sigContextMenuRequested("popupFolderTableColumns", point);
					break; 
				
				case KPGTreeItem::nodeFolderTableIndexes:
				  emit sigContextMenuRequested("popupFolderTableIndexes", point);
					break; 
				
				case KPGTreeItem::nodeFolderTableConstraints:
				  emit sigContextMenuRequested("popupFolderTableConstraints", point);
					break;
				
				case KPGTreeItem::nodeFolderRules:
				  emit sigContextMenuRequested("popupFolderRules", point);
					break; 
				
				case KPGTreeItem::nodeFolderTriggers:
				  emit sigContextMenuRequested("popupFolderTriggers", point);
					break;
				
        //******************************************************************************************
        //
        // Domain objects folders
        //
        //******************************************************************************************
				
        
        case KPGTreeItem::nodeFolderDomainConstraints:
          emit sigContextMenuRequested("popupFolderDomainConstraints", point);
          break;
          
        case KPGTreeItem::nodeDomainConstr:
          emit sigContextMenuRequested("popupDomainConstraint", point);
          break;
        
				//******************************************************************************************
				//
				// Table objects
				//
				//******************************************************************************************
												
				case KPGTreeItem::nodeTableColumn:
          emit sigContextMenuRequested("popupTableColumn", point);
					break;
				
				case KPGTreeItem::nodePrimaryKeyConstr:
        case KPGTreeItem::nodeForeignKeyConstr:
        case KPGTreeItem::nodeUniqueConstr:
        case KPGTreeItem::nodeCheckConstr:
          emit sigContextMenuRequested("popupTableConstraint", point);
					break;
									 
				case KPGTreeItem::nodePrimaryKey:
				case KPGTreeItem::nodeIndex:
					emit sigContextMenuRequested("popupTableIndex", point);
					break; 
				
				case KPGTreeItem::nodeRule:
          emit sigContextMenuRequested("popupRule", point);
					break; 
				
				case KPGTreeItem::nodeTrigger:
          emit sigContextMenuRequested("popupTrigger", point);
					break; 
          
        //******************************************************************************************
				
				case KPGTreeItem::nodeUnselected:
					break; 
          
        default:
          kdDebug() << "KPoGreView::slotTreeViewRightButtonPressed - unhandled object type ! " << pItem->text(0) << endl;
          break;
      }
		}
}

// Checks, which type of item was selected
void KPoGreView::slotSelectionChanged()
{
	setWaitCursor();	
		
	KPGTreeItem * pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if ( ! pItem )
		{ emit sigSelectionChanged(KPGTreeItem::nodeUnselected, 0, m_stackBackNodes.count(), m_stackForwardNodes.count());
      createPropertiesTab(KPGTreeItem::nodeUnselected);
      setNormalCursor();
			return;
    }
	else
    {
      emit sigSelectionChanged(pItem->type(), pItem, m_stackBackNodes.count(), m_stackForwardNodes.count());
      createPropertiesTab(pItem->type());
    }
		
	if(pItem->type() != KPGTreeItem::nodeUnselected)
	{
		pItem->displayProperties(m_pWidgetProperties);
	}
	
	setNormalCursor();
}

// Caled when user change selected server in SQL query / result window
// Set server's databases to combobox in SQL query / result window
void KPoGreView::slotRequestDatabasesList(KPGSqlQueryResultWindow *pQueryResultWindow, const QString& strServer)
{
	pQueryResultWindow->m_pComboBoxDatabase->clear();
		
	QStringList strLisOfActiveDbConnections;
		
	QListViewItem * pItem = m_pViewTree->firstChild();
	while(pItem)
	{
		if((static_cast <KPGTreeItem *> (pItem))->type() == KPGTreeItem::nodeServer)
		{
			KPGServer *pServer = static_cast <KPGServer *> (pItem);
			if(pServer->text(0) != strServer)
			{
				pItem = pItem->nextSibling(); continue;
			}
								
			//--- traverse list of connected databases
			QListViewItem * pItem2 = pServer->firstChild();
			if(pItem2)
				emit sigEnableRunQueryAction(true);

			while(pItem2)
			{
				if((static_cast <KPGTreeItem *> (pItem2))->type() == KPGTreeItem::nodeDatabase)
				{
					KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pItem2);
					if(pDatabase->connection())
						pQueryResultWindow->m_pComboBoxDatabase->insertItem(*pDatabase->pixmap(0), pDatabase->text(0));
				}
					
				pItem2 = pItem2->nextSibling();
			}	 
		}
		pItem = pItem->nextSibling();
	}
}

// Called from property pages when user double-clicks on KPGLinkLabel
void KPoGreView::slotSearchObject(const pqxx::oid _oid)
{
	// Start find from current items parent server
	KPGTreeItem *pItem = static_cast <KPGTreeItem *> (m_pViewTree->selectedItem());

	if(!pItem)
		{
		  KMessageBox::sorry(this, i18n("No item selected "));
			kdError() << "KPoGreView::slotSearchObject - item is not selected " << endl;
			return;    
		}
		
	// Store pointer to old item
	KPGTreeItem *pOldItem = pItem;

	// Go up to parent server
	while(pItem->type() != KPGTreeItem::nodeServer)
	{
		pItem = static_cast <KPGTreeItem *> (pItem->parent());
		if(!pItem)
		{
		  kdError() << "KPoGreView::slotSearchObject - internal error !!!" << endl;
			return;    
		}
	}

	//--- Search item ---------------------------------
	while(pItem)
	{
		if((pItem->hasOid()))
		{
			KPGObject *pObject = static_cast <KPGObject *> (pItem);
			
			if(pObject->oid() == _oid)
			{
				// store info about previously selected item to stack
				if((pOldItem->hasOid()))
				{
					KPGObject *pOldObject = static_cast <KPGObject *> (pOldItem);
					m_stackBackNodes.push(KPGOidLink(pOldObject->oid(), pOldObject->path()));
				}
				else
					m_stackBackNodes.push(KPGOidLink(0, pOldItem->path()));
				
				m_stackForwardNodes.clear();
					
				// select new item
				selectItem(pItem);
				
				return;
			}
		}
		
		pItem = nextTreeItem(pItem);
	}
	
	KMessageBox::sorry(this, i18n("Searched item not found"));
}

// Called when user change SQL query in editor
void KPoGreView::slotQueryTextChanged(KPGSqlQueryResultWindow *pQueryResultWindow)
{
	emit sigEnableFileActions(true, true, !pQueryResultWindow->resultEmpty());
	
	emit sigEnableEditActions(pQueryResultWindow->editQuery()->isUndoAvailable(),
														pQueryResultWindow->editQuery()->isRedoAvailable(), 
														pQueryResultWindow->editQuery()->hasSelectedText(),
														true,
														m_pViewTree->selectedItem() != 0, 
														pQueryResultWindow->editQuery()->length() > 0
													 );
}

// Called when availability of copy action is changed in SQL query editor
void KPoGreView::slotCopyAvailable(KPGSqlQueryResultWindow *pQueryResultWindow, bool bCopyAvailable)
{
	emit sigEnableEditActions(pQueryResultWindow->editQuery()->isUndoAvailable(),
														pQueryResultWindow->editQuery()->isRedoAvailable(), 
														bCopyAvailable,
														true,
														m_pViewTree->selectedItem() != 0, 
														pQueryResultWindow->editQuery()->length() > 0
													 );
}

// Called when availability of undo action is changed in SQL query editor
void KPoGreView::slotUndoAvailable(KPGSqlQueryResultWindow *pQueryResultWindow, bool bUndoAvailable)
{
	emit sigEnableEditActions(bUndoAvailable,
														pQueryResultWindow->editQuery()->isRedoAvailable(), 
														pQueryResultWindow->editQuery()->hasSelectedText(),
														true,
														m_pViewTree->selectedItem() != 0, 
														pQueryResultWindow->editQuery()->length() > 0
													 );
}
	
// Called when availability of redo action is changed in SQL query editor
void KPoGreView::slotRedoAvailable(KPGSqlQueryResultWindow *pQueryResultWindow, bool bRedoAvailable)
{
	emit sigEnableEditActions(pQueryResultWindow->editQuery()->isUndoAvailable(),
														bRedoAvailable, 
														pQueryResultWindow->editQuery()->hasSelectedText(),
														true,
														m_pViewTree->selectedItem() != 0, 
														pQueryResultWindow->editQuery()->length() > 0
													 );
}

/////////////////////////////////////////////////////////////////////
//                       WIZARDS FUNCTIONS
/////////////////////////////////////////////////////////////////////


// Run Create Database Wizard 
bool KPoGreView::createDatabaseWizard(KPGServer *pServer)
{
	KPGCreateDatabaseWizard wzd(this, "Create new database", pServer);
			
	wzd.setConnection(pServer->connection());
		
	if(wzd.exec() != QDialog::Accepted)
     return false;
  
	return true;
}

// Run Create Tablespace Wizard 
bool KPoGreView::createTablespaceWizard(KPGServer *pServer)
{
  KPGCreateTablespaceWizard wzd(this, "KPGCreateTablespaceWizard", pServer);
  wzd.setConnection(pServer->connection());
  
  if(wzd.exec() != QDialog::Accepted)
     return false;
     
  return true;
}

// Run Create Group Wizard 
bool KPoGreView::createGroupWizard(KPGServer *pServer)
{
	KPGCreateGroupWizard wzd(this, "KPGCreateGroupWizard", pServer->getUsersFolder());
	wzd.setConnection(pServer->connection());
	
	if(wzd.exec() != QDialog::Accepted)
     return false;
		 
	return true;
}

// Run Create User Wizard 
bool KPoGreView::createUserWizard(KPGServer *pServer)
{
	KPGCreateUserWizard wzd(this, "KPGCreateUserWizard", pServer);
	wzd.setConnection(pServer->connection());
	
	if(wzd.exec() != QDialog::Accepted)
     return false;
		 
	return true;
}

// Run Create Schema Wizard 
bool KPoGreView::createSchemaWizard(KPGDatabase *pDatabase)
{
	KPGCreateSchemaWizard wzd(this, "KPGCreateSchemaWizard", pDatabase);
	wzd.setConnection(pDatabase->connection());
	
	if(wzd.exec() != QDialog::Accepted)
     return false;
		 
	return true;
}

// Run Create Language Wizard 
bool KPoGreView::createLanguageWizard(KPGDatabase *pDatabase)
{
  KPGCreateLanguageWizard wzd(this, "KPGCreateLanguageWizard", pDatabase);
  wzd.setConnection(pDatabase->connection());
  
  if(wzd.exec() != QDialog::Accepted)
     return false;
     
  return true;
}

// Run Create Table Wizard 
bool KPoGreView::createTableWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
	KPGCreateTableWizard wzd(this, "KPGCreateTableWizard", pDatabase, listOfSchemas);
  wzd.setConnection(pDatabase->connection());
	
	if(wzd.exec() != QDialog::Accepted)
     return false;
  
	return true;
}

// Run Create Type Wizard 
bool KPoGreView::createBaseTypeWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
  KPGCreateBaseTypeWizard wzd(this, "KPGCreateBaseTypeWizard", pDatabase, listOfSchemas);
  wzd.setConnection(pDatabase->connection());
          
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Type Wizard 
bool KPoGreView::createCompositeTypeWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
  KPGCreateCompositeTypeWizard wzd(this, "KPGCreateCompositeTypeWizard", pDatabase, listOfSchemas);
  wzd.setConnection(pDatabase->connection());
          
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create View Wizard 
bool KPoGreView::createViewWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
	KPGCreateViewWizard wzd(this, "KPGCreateViewWizard", pDatabase, listOfSchemas);
	wzd.setConnection(pDatabase->connection());
  
	if(wzd.exec() != QDialog::Accepted)
     return false;
  
	return true;
}

// Run Create Domain Wizard 
bool KPoGreView::createDomainWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
  KPGCreateDomainWizard wzd(this, "KPGCreateDomainWizard", pDatabase, listOfSchemas);
  wzd.setConnection(pDatabase->connection());
  
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Function Wizard 
bool KPoGreView::createFunctionWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
  KPGCreateFunctionWizard wzd(this, "KPGCreateFunctionWizard", pDatabase, listOfSchemas);
  wzd.setConnection(pDatabase->connection());
  
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Sequence Wizard 
bool KPoGreView::createSequenceWizard(KPGDatabase *pDatabase, QPtrList<QListViewItem> & listOfSchemas)
{
  KPGCreateSequenceWizard wzd(this, "KPGCreateSequenceWizard", listOfSchemas);
  wzd.setConnection(pDatabase->connection());
  
  wzd.setConnection(pDatabase->connection());
    
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run simple 2-steps for dropping DB object
bool KPoGreView::dropObjectWizard(
	KPGTreeItem * pSelectedItem, 				// item to DROP
	KPGTreeItem::eNodeType nodeType, 		// object type
	const char *szObjectTypeName, 			// user for  SQL statement - DROP OBJECTYPE
	KPGConnection *pConnection, 				// connection for SQL operation
	const QString &strSchemaName,				// optional schema name
  bool bWithTransaction               // run SQL with transaction
	)
{
	if((static_cast <KPGTreeItem *> (pSelectedItem))->type() != nodeType)
	{
		kdDebug() << "KPoGreView::dropDbObject: item types mismatch" << endl;
		return false;
	}
		
	QString strSQL("DROP ");
	strSQL.append(szObjectTypeName);
	strSQL.append(" ");
	
	if(strSchemaName.length() > 0)
	{
		strSQL.append(strSchemaName);
		strSQL.append(".");
	}
	
	// object name
	strSQL.append(pSelectedItem->text(0));
	strSQL.append(";");
	
	KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, bWithTransaction);
	wzd.setConnection(pConnection);
		
	if(wzd.exec() != QDialog::Accepted)
     return false;
  
	// Refresh parent item
	setWaitCursor();
	
	if(nodeType == KPGTreeItem::nodeSchema)
	{
		KPGDatabase *pDatabase = static_cast <KPGDatabase *> (pSelectedItem->parent());
		pDatabase->refresh();
	}
	else
	{		
		pqxx::work pqxxXaction(* pConnection, "refresh folder");
		KPGItemsFolder *pParentFolder = static_cast <KPGItemsFolder *> (pSelectedItem->parent());
		pParentFolder->refresh(pqxxXaction);
	}
	
	setNormalCursor();

	return true;
}

// Run simple 2-steps for dropping Table child object, using ALTER table DROP ...
bool KPoGreView::dropTableObjectWizard(
	KPGTreeItem * pSelectedItem, 				// item to DROP
	const char *szObjectTypeName, 			// user for  SQL statement - DROP OBJECTYPE
	KPGConnection *pConnection, 				// connection for SQL operation
	const QString &strSchemaName,				// schema name
  const QString &strTableName,				// table name
	bool bWithTransaction               // run SQL with transaction
	)
{
	QString strSQL("ALTER TABLE ");
	strSQL.append(strSchemaName);
	strSQL.append(".");
	strSQL.append(strTableName);
	strSQL.append(" DROP ");
	strSQL.append(szObjectTypeName);
	strSQL.append(" ");
	strSQL.append(pSelectedItem->text(0));
	strSQL.append(";");
	
	KPG2StepsWizard wzd(this, "KPG2StepsWizard", strSQL, bWithTransaction);
	wzd.setConnection(pConnection);
		
	if(wzd.exec() != QDialog::Accepted)
     return false;
  
	// Refresh parent item
	setWaitCursor();
	
	KPGTableItemsFolder *pParentFolder = static_cast <KPGTableItemsFolder *> (pSelectedItem->parent());
	pParentFolder->refresh();
		
	setNormalCursor();

	return true;
}

// Run ALTER table ADD Column Wizard
bool KPoGreView::createColumnWizard(KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable)
{
  KPGCreateTableColumnWizard wzd(this, "KPGCreateTableColumnWizard", pDatabase, pSchema->text(0), pTable->text(0));
  wzd.setConnection(pDatabase->connection());
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Constraint Wizard 
bool KPoGreView::createConstraintWizard(KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable, int iRaisedWidget)
{
  KPGCreateTableConstraintWizard wzd(this, "KPGCreateTableConstraintWizard", pDatabase, pSchema, pTable, pTable->primaryKeyName().isEmpty(), iRaisedWidget);
  wzd.setConnection(pDatabase->connection());
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Index Wizard 
bool KPoGreView::createIndexWizard(KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable)
{
  KPGCreateTableIndexWizard wzd(this, "KPGCreateTableIndexWizard", pDatabase, pSchema, pTable);
  wzd.setConnection(pDatabase->connection());
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Rule Wizard 
bool KPoGreView::createRuleWizard(KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable)
{
  KPGCreateRuleWizard wzd(this, "KPGCreateRuleWizard", pSchema, pTable);
  wzd.setConnection(pDatabase->connection());
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}

// Run Create Trigger Wizard 
bool KPoGreView::createTriggerWizard(KPGDatabase *pDatabase, KPGSchema *pSchema, KPGTable *pTable)
{
  KPGCreateTriggerWizard wzd(this, "KPGCreateTriggerWizard", pSchema, pTable);
  wzd.setConnection(pDatabase->connection());
  if(wzd.exec() != QDialog::Accepted)
     return false;
  
  return true;
}
